#pragma rtGlobals=1		// Use modern global access method.



Function createSonarDomePlots()
	SubtractMeanFromAllWaves()
	Display /W=(0,0,800,600) G24,G26,G21,G28,G29,G25,G33,G32,G31,G34
	Label bottom "Seconds"
	Label left "KPa"
	
	ModifyGraph rgb(G24)=(0,0,0)
	ModifyGraph rgb(G26)=(65280,16384,16384)
	ModifyGraph rgb(G21)=(0,39168,0)
	ModifyGraph rgb(G28)=(0,0,65280)
	ModifyGraph rgb(G29)=(39168,0,31232)
	ModifyGraph rgb(G25)=(47872,47872,47872)
	ModifyGraph rgb(G33)=(65280,32768,32768)
	ModifyGraph rgb(G32)=(0,65280,0)
	ModifyGraph rgb(G31)=(16384,65280,65280)
	ModifyGraph rgb(G34)=(65280,32768,58880)
	
	Legend/C/X=50/Y=30/N=text0/A=MC
	//Legend/C/X=40/Y=30/N=text0/A=MC	
	
	TextBox/C/X=0/Y=40/N=text1/A=MC "DDX Storm Draft\rSonar Dome Impact Event\rCondition:\rRun:"
	
	//AppendToGraph averagepressure
	//ModifyGraph lsize(averagepressure)=1.5,rgb(averagepressure)=(52224,0,0)
End//sonarDomePlots

Function createSonarDomePlotsWithAP()
	//SubtractMeanFromAllWaves()
	Display /W=(0,0,800,600) G24,G26,G21,G28,G29,G25,G33,G32,G31,G34
	Label bottom "Seconds"
	Label left "KPa"
	
	ModifyGraph rgb(G24)=(0,0,0)
	ModifyGraph rgb(G26)=(65280,16384,16384)
	ModifyGraph rgb(G21)=(0,39168,0)
	ModifyGraph rgb(G28)=(0,0,65280)
	ModifyGraph rgb(G29)=(39168,0,31232)
	ModifyGraph rgb(G25)=(47872,47872,47872)
	ModifyGraph rgb(G33)=(65280,32768,32768)
	ModifyGraph rgb(G32)=(0,65280,0)
	ModifyGraph rgb(G31)=(16384,65280,65280)
	ModifyGraph rgb(G34)=(65280,32768,58880)
	
	//Legend/C/X=50/Y=30/N=text0/A=MC
	Legend/C/X=40/Y=30/N=text0/A=MC	
	
	TextBox/C/X=0/Y=40/N=text1/A=MC "DDX Storm Draft\rSonar Dome Impact Event\rCondition:\rRun:"
	
	execute "createaveragepressure()"
	AppendToGraph averagepressure9
	ModifyGraph lsize(averagepressure9)=1.5,rgb(averagepressure9)=(52224,0,0)
End//createSonarDomePlotsWithAveragePressure




Function DDXModelSDFASTLoadFile(fname,scale)
	String fname
	Variable scale
	loadGenericSCLFileSP4BHBF(fname)
	if(scale == 1)
		DDXModelSDFASTRenameScale("wave")
	endif
End//DDXModelSDFASTLoadFile

Function DDXModelSDFASTRenameScale(waveprefix)
	String waveprefix
	Variable FastSampleRate = 7302.96743
	Variable FastDeltaT = 1/FastSampleRate

	skr(waveprefix+"0",212.078,FastDeltaT,"G22")
	skr(waveprefix+"1",212.078,FastDeltaT,"G24")
	skr(waveprefix+"2",212.078,FastDeltaT,"G26")
	skr(waveprefix+"3",212.078,FastDeltaT,"G30")
	skr(waveprefix+"4",212.078,FastDeltaT,"G1")
	skr(waveprefix+"5",212.078,FastDeltaT,"G2")
	skr(waveprefix+"6",212.078,FastDeltaT,"AGS Face")
	skr(waveprefix+"7",212.078,FastDeltaT,"G21")
	skr(waveprefix+"8",212.078,FastDeltaT,"G28")
	skr(waveprefix+"9",212.078,FastDeltaT,"G39")
	skr(waveprefix+"10",212.078,FastDeltaT,"G29")
	skr(waveprefix+"11",212.078,FastDeltaT,"G25")
	skr(waveprefix+"12",212.078,FastDeltaT,"G23")
	skr(waveprefix+"13",212.078,FastDeltaT,"G33")
	skr(waveprefix+"14",212.078,FastDeltaT,"G32")
	skr(waveprefix+"15",212.078,FastDeltaT,"G31")
	skr(waveprefix+"16",212.078,FastDeltaT,"G36")
	skr(waveprefix+"17",212.078,FastDeltaT,"G34")
End//DDXModelSDFASTRenameScale






Function DDXModelSDMEDIUMLoadFile(fname,scale)
	String fname
	variable scale
	loadGenericSCLFileSP4BHBF(fname)
	if(scale == 1)
		DDXModelSDMEDIUMRenameScale("wave")
	endif
End//DDXModelSDMEDIUMLoadFile


Function DDXModelSDMEDIUMRenameScale(waveprefix)
	String waveprefix
	Variable MediumSampleRate = 1825.74186
	Variable MediumDeltaT = 1/MediumSampleRate

	skr(waveprefix+"0",212.078,MediumDeltaT,"P07")
	skr(waveprefix+"1",212.078,MediumDeltaT,"P06")
	skr(waveprefix+"2",212.078,MediumDeltaT,"P10")
	skr(waveprefix+"3",212.078,MediumDeltaT,"P09")
	skr(waveprefix+"4",212.078,MediumDeltaT,"P01")
	skr(waveprefix+"5",212.078,MediumDeltaT,"P30")
	skr(waveprefix+"6",212.078,MediumDeltaT,"P31")
	skr(waveprefix+"7",212.078,MediumDeltaT,"P04")
	skr(waveprefix+"8",212.078,MediumDeltaT,"P03")
	skr(waveprefix+"9",212.078,MediumDeltaT,"P15")
	skr(waveprefix+"10",212.078,MediumDeltaT,"P18")
	skr(waveprefix+"11",212.078,MediumDeltaT,"P23")
	skr(waveprefix+"12",212.078,MediumDeltaT,"P25")
	skr(waveprefix+"13",212.078,MediumDeltaT,"P26")
	skr(waveprefix+"14",212.078,MediumDeltaT,"P20")
	skr(waveprefix+"15",212.078,MediumDeltaT,"P27")
	skr(waveprefix+"16",212.078,MediumDeltaT,"P28")


End//DDXModelSDMEDIUMRenameScale

























Function DDXModelFLD2FASTLoadFile(fname,scale)
	String fname
	Variable scale
	loadGenericSCLFileSP4BHBF(fname)
	if(scale == 1)
		DDXModelFLD2FASTRenameScale("wave")
	endif
End//DDXModelFLD2FASTLoadFile

Function DDXModelFLD2FASTRenameScale(waveprefix)
	String waveprefix
	Variable FastSampleRate = 3651.4837
	Variable FastDeltaT = 1/FastSampleRate

	skr(waveprefix+"0",212.078,FastDeltaT,"G22")
	skr(waveprefix+"1",212.078,FastDeltaT,"G24")
	skr(waveprefix+"2",212.078,FastDeltaT,"G26")
	skr(waveprefix+"3",212.078,FastDeltaT,"G30")
	skr(waveprefix+"4",212.078,FastDeltaT,"G1")
	skr(waveprefix+"5",212.078,FastDeltaT,"G2")
	skr(waveprefix+"6",212.078,FastDeltaT,"AGS Face")
	skr(waveprefix+"7",212.078,FastDeltaT,"G21")
	skr(waveprefix+"8",212.078,FastDeltaT,"G28")
	skr(waveprefix+"9",212.078,FastDeltaT,"G29")
	skr(waveprefix+"10",212.078,FastDeltaT,"G25")
	skr(waveprefix+"11",212.078,FastDeltaT,"G23")
	skr(waveprefix+"12",212.078,FastDeltaT,"G33")
	skr(waveprefix+"13",212.078,FastDeltaT,"G32")
	skr(waveprefix+"14",212.078,FastDeltaT,"G31")
	skr(waveprefix+"15",212.078,FastDeltaT,"G36")

End//DDXModelFLD2FASTRenameScale






Function DDXModelFLD2MEDIUMLoadFile(fname,scale)
	String fname
	variable scale
	loadGenericSCLFileSP4BHBF(fname)
	if(scale == 1)
		DDXModelFLD2MEDIUMRenameScale("wave")
	endif
End//DDXModelFLD2MEDIUMLoadFile


Function DDXModelFLD2MEDIUMRenameScale(waveprefix)
	String waveprefix
	Variable MediumSampleRate = 912.8709
	Variable MediumDeltaT = 1/MediumSampleRate

	skr(waveprefix+"0",212.078,MediumDeltaT,"P07")
	skr(waveprefix+"1",212.078,MediumDeltaT,"P08")
	skr(waveprefix+"2",212.078,MediumDeltaT,"P05")
	skr(waveprefix+"3",212.078,MediumDeltaT,"P10")
	skr(waveprefix+"4",212.078,MediumDeltaT,"P09")
	skr(waveprefix+"5",212.078,MediumDeltaT,"P06")
	skr(waveprefix+"6",212.078,MediumDeltaT,"P01")
	skr(waveprefix+"7",212.078,MediumDeltaT,"P30")
	skr(waveprefix+"8",212.078,MediumDeltaT,"P31")
	skr(waveprefix+"9",212.078,MediumDeltaT,"P04")
	skr(waveprefix+"10",212.078,MediumDeltaT,"P03")
	skr(waveprefix+"11",212.078,MediumDeltaT,"P15")
	skr(waveprefix+"12",212.078,MediumDeltaT,"P18")
	skr(waveprefix+"13",212.078,MediumDeltaT,"P23")
	skr(waveprefix+"14",212.078,MediumDeltaT,"P25")
	skr(waveprefix+"15",212.078,MediumDeltaT,"P26")
	skr(waveprefix+"16",212.078,MediumDeltaT,"P20")
	skr(waveprefix+"17",212.078,MediumDeltaT,"P27")
	skr(waveprefix+"18",212.078,MediumDeltaT,"P28")


End//DDXModelFLD2MEDIUMRenameScale








Function DDXModelFLD2SLOWLoadFile(fname,scale)
	String fname
	variable scale
	loadGenericSCLFileSP4BHBF(fname)
	if(scale == 1)
		DDXModelFLD2SLOWRenameScale("wave")
	endif
End//DDXModelFLD2SLOWLoadFile

Function DDXModelFLD2SLOWRenameScale(waveprefix)
	String waveprefix
	Variable SlowSampleRate = 36.5148
	Variable SlowDeltaT = 1/SlowSampleRate

	skr(waveprefix+"0",9.5711,SlowDeltaT,"Vert Bnd Sta 4")
	skr(waveprefix+"1",9.5711,SlowDeltaT,"Lat Bnd Sta 4")
	skr(waveprefix+"2",12.56,SlowDeltaT,"Lat Shear Sta 4")
	skr(waveprefix+"3",12.56,SlowDeltaT,"Vert Shear Sta 4")
	skr(waveprefix+"4",9.5711,SlowDeltaT,"Torsion Sta 4")
	skr(waveprefix+"5",9.5711,SlowDeltaT,"Torsion Sta 7")
	skr(waveprefix+"6",9.5711,SlowDeltaT,"Lat Bnd Sta 7")
	skr(waveprefix+"7",12.56,SlowDeltaT,"Vert Shear Sta 7")
	skr(waveprefix+"8",9.5711,SlowDeltaT,"Vert Bnd Sta 7")
	skr(waveprefix+"9",12.56,SlowDeltaT,"Lat Shear Sta 7")
	skr(waveprefix+"10",9.5711,SlowDeltaT,"Vert Bnd Sta 10")
	skr(waveprefix+"11",9.5711,SlowDeltaT,"Lat Bnd Sta 10")
	skr(waveprefix+"12",12.56,SlowDeltaT,"Vert Shear Sta 10")
	skr(waveprefix+"13",12.56,SlowDeltaT,"Lat Shear Sta 10")
	skr(waveprefix+"14",9.5711,SlowDeltaT,"Torsion Sta 10")
	skr(waveprefix+"15",9.5711,SlowDeltaT,"Vert Bnd Sta 13")
	skr(waveprefix+"16",9.5711,SlowDeltaT,"Lat Bnd Sta 13")
	skr(waveprefix+"17",12.56,SlowDeltaT,"Vert Shear Sta 13")
	skr(waveprefix+"18",12.56,SlowDeltaT,"Lat Shear Sta 13")
	skr(waveprefix+"19",9.5711,SlowDeltaT,"Torsion Sta 13")
	skr(waveprefix+"20",9.5711,SlowDeltaT,"Vert Bnd Sta 16.5")
	skr(waveprefix+"21",9.5711,SlowDeltaT,"Lat Bnd Sta 16.5")
	skr(waveprefix+"22",12.56,SlowDeltaT,"Vert Shear Sta 16.5")
	skr(waveprefix+"23",12.56,SlowDeltaT,"Lat Shear Sta 16.5")
	skr(waveprefix+"24",9.5711,SlowDeltaT,"Torsion Sta 16")
	skr(waveprefix+"25",1,SlowDeltaT,"FWD LIFT")
	skr(waveprefix+"26",1,SlowDeltaT,"AFT LIFT")
	skr(waveprefix+"27",0.762,SlowDeltaT,waveprefix+" Ht West")
	skr(waveprefix+"28",0.762,SlowDeltaT,waveprefix+" Ht North")
	skr(waveprefix+"29",0.762,SlowDeltaT,waveprefix+" Ht South")
	skr(waveprefix+"30",1,SlowDeltaT,"Carriage Speed")
	skr(waveprefix+"31",1,SlowDeltaT,"Stern Lat Acc")
	skr(waveprefix+"32",1,SlowDeltaT,"Stern Vert Acc")
	skr(waveprefix+"33",1,SlowDeltaT,"Lat Bow Acc")
	skr(waveprefix+"34",1,SlowDeltaT,"Vert Bow Acc")
	skr(waveprefix+"35",1,SlowDeltaT,"CG Lat Acc")
	skr(waveprefix+"36",1,SlowDeltaT,"CG Vert Acc")
	skr(waveprefix+"37",1,SlowDeltaT,"Pitch Angle")
	skr(waveprefix+"38",1,SlowDeltaT,"Roll Angle")


End//DDXModelFLD2SLOWRenameScale





//this functioncreates a moving color stripchart
//deletes waves
function imageplotsdistructive()

string prefix = "graph"
string suffix = ".bmp"
string filename

Make/N=(1000,16) matrix

wave wmatrix = matrix

Display /W=(0,0,160,120);AppendImage matrix
ModifyImage matrix ctab= {*,*,Rainbow,0}

variable i

for(i=1; i<500*10;i+=1)

wave fwave0 = G22
wmatrix[][0] = fwave0

wave fwave1 = G24
wmatrix[][1] = fwave1

wave fwave2 = G26
wmatrix[][2] = fwave2

wave fwave3 = G30
wmatrix[][3] = fwave3

wave fwave4 = G1
wmatrix[][4] = fwave4

wave fwave5 = G2
wmatrix[][5] = fwave5

wave fwave6 = 'AGS Face'
wmatrix[][6] = fwave6

wave fwave7 = G21
wmatrix[][7] = fwave7

wave fwave8 = G28
wmatrix[][8] = fwave8

wave fwave9 = G29
wmatrix[][9] = fwave9

wave fwave10 = G25
wmatrix[][10] = fwave10

wave fwave11 = G23
wmatrix[][11] = fwave11

wave fwave12 = G33
wmatrix[][12] = fwave12

wave fwave13 = G32
wmatrix[][13] = fwave13

wave fwave14 = G31
wmatrix[][14] = fwave14

wave fwave15 = G36
wmatrix[][15] = fwave15

print i

filename = prefix + num2str(i) + suffix
print filename
SavePICT/P=home/E=-4/B=72 as filename
DeletePoints 0,100, G22,G24,G26,G30,G1,G2,'AGS Face',G21,G28,G29,G25,G23,G33,G32,G31,G36;DelayUpdate
endfor


end //imageplotsdistructive




//this function creates a 13x3 station grid where color changes
function imageplots2()

execute "createaveragepressure()"

string prefix = "graph"
string suffix = ".bmp"
string filename

Make/O/N=(13,3) matrix2

wave wmatrix = matrix2

Display /W=(0,0,320,240);AppendImage matrix2
//ModifyImage matrix2 ctab= {*,*,Rainbow,0}
//ModifyImage matrix2 ctab= {0,3700,Rainbow,1}
//ModifyImage matrix2 ctab= {0,13500,Rainbow,1}
ModifyImage matrix2 ctab= {-200,700,Rainbow,1}
ColorScale/C/N=text0/X=5.00/Y=5.00/E image=matrix2

Label left "Bow"
ModifyGraph manTick(left)={0,1,0,0},manMinor(left)={0,0}
Label bottom "Starboard"
ModifyGraph manTick(bottom)={0,1,0,0},manMinor(bottom)={0,0}

//TextBox/C/N=text1/Z=1/A=LT/X=0.00/Y=0.00/E "DDX SD\rHC10KH0P2R4"

variable i

for(i=0; i<9300;i+=1)

TextBox/C/N=text1/Z=1/A=LT/X=0.00/Y=0.00/E "DDX SD Frame " + num2str(i) + "\rCamille 10K H0 P2 R4"


//wave fwave00 =
//wmatrix[0][0] = fwave00[i]

wave fwave01 = G1
wmatrix[0][1] = fwave01[i]

wave fwave02 = averagepressure9
wmatrix[0][2] = fwave02[i]


//wave fwave10 =
//wmatrix[1][0] = fwave10[i]

//wave fwave11 =
//wmatrix[1][1] = fwave11[i]

//wave fwave12 =
//wmatrix[1][2] = fwave12[i]


//wave fwave20 =
//wmatrix[2][0] = fwave20[i]

wave fwave21 = G23
wmatrix[2][1] = fwave21[i]

//wave fwave22 =
//wmatrix[2][2] = fwave22[i]


wave fwave30 = G26
wmatrix[3][0] = fwave30[i]

wave fwave31 = G25
wmatrix[3][1] = fwave31[i]

wave fwave32 = G24
wmatrix[3][2] = fwave32[i]


wave fwave40 = G29
wmatrix[4][0] = fwave40[i]

wave fwave41 = G21
wmatrix[4][1] = fwave41[i]

wave fwave42 = G28
wmatrix[4][2] = fwave42[i]


//wave fwave50 =
//wmatrix[5][0] = fwave50[i]

wave fwave51 = G31
wmatrix[5][1] = fwave51[i]

//wave fwave52 =
//wmatrix[5][2] = fwave52[i]


wave fwave60 = G34
wmatrix[6][0] = fwave60[i]

wave fwave61 = G33
wmatrix[6][1] = fwave61[i]

wave fwave62 = G32
wmatrix[6][2] = fwave62[i]


//wave fwave70 = G37
//wmatrix[7][0] = fwave70[i]

wave fwave71 = G36
wmatrix[7][1] = fwave71[i]

//wave fwave72 = G35
//wmatrix[7][2] = fwave72[i]


//wave fwave80 = G40
//wmatrix[8][0] = fwave80[i]

wave fwave81 = G39
wmatrix[8][1] = fwave81[i]

//wave fwave82 = G38
//wmatrix[8][2] = fwave82[i]


//wave fwave90 = G43
//wmatrix[9][0] = fwave90[i]

//wave fwave91 = G42
//wmatrix[9][1] = fwave91[i]

//wave fwave92 = G41
//wmatrix[9][2] = fwave92[i]


//wave fwave100 =
//wmatrix[10][0] = fwave100[i]

wave fwave101 = G22
wmatrix[10][1] = fwave101[i]

//wave fwave102 =
//wmatrix[10][2] = fwave102[i]


//wave fwave110 =
//wmatrix[11][0] = fwave110[i]

//wave fwave111 =
//wmatrix[11][1] = fwave111[i]

//wave fwave112 =
//wmatrix[11][2] = fwave112[i]


//wave fwave120 =
//wmatrix[12][0] = fwave120[i]

wave fwave121 = G2
wmatrix[12][1] = fwave121[i]

//wave fwave122 =
//wmatrix[12][2] = fwave122[i]


print i

filename = prefix + num2str(i) + suffix
print filename

SavePICT/O/P=home/E=-4/B=72 as filename

endfor



end //imageplots2





macro createaveragepressure()

Duplicate/O G21 averagepressure9, averagepressure3
//averagepressure = (G1+G26+G25+G24+G29+G21+G28+G31+G33+G32+G36+G22+G2)/13
//ddxfld2 averagepressure = (G26+G25+G24+G29+G21+G28+G31+G33+G32+G36+G22)/11
//ddxsd
//averagepressure = (G22+G24+G26+G1+G2+G21+G28+G39+G29+G25+G23+G33+G32+G31+G36+G34)/16
//ddxsd
averagepressure9 = (G32+G33+G34+G28+G21+G29+G24+G25+G26)/9
averagepressure3 = (G21+G25+G23)/3

end //createaveragepressure





