#pragma rtGlobals=1		// Use modern global access method.


function RAO()

	variable /g seglen
	variable tempseglen = seglen
	prompt tempseglen,"Segment Length",popup "256;512;1024;2048;4096;8192;16384;32768;65536"
	
	variable /g windowtype
	variable tempwindowtype = windowtype
	prompt tempwindowtype,"Window Type",popup "Square;Hann;Parzen;Welch;Hamming;BlackmanHarris3;KaiserBessel"


	String /g wname //stores the selected wave name
	string tempwname = wname
	Prompt tempwname,"Numerator Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	String /g divwname //stores the selected wave name
	string tempdivwname = divwname
	Prompt tempdivwname,"Denominator Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	
	variable V_Flag
	DoPrompt "RAO Analysis",tempwname,tempdivwname,tempseglen,tempwindowtype //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif
	

	wname = tempwname
	divwname = tempdivwname
	seglen = tempseglen
	windowtype = tempwindowtype
	
	
	//compute psd on each wave
	execute "PSD(wname,seglen,windowtype)"
	execute "PSD(divwname,seglen,windowtype)"
	
	//divide out numerator psd by denominator psd
	string psd1name = wname + "_psd"
	string psd2name = divwname + "_psd"
	string raoname = wname + "_rao"
	duplicate /O $psd1name, $raoname
	wave rao = $raoname
	wave psd1 = $psd1name
	wave psd2 = $psd2name
	rao = sqrt(psd1/psd2)
	
	display rao

end



function encounter2wave()

	String /g wname //stores the selected wave name
	string tempwname = wname
	Prompt tempwname,"Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	
	variable /g deltafreq
	variable tempdeltafreq = deltafreq
	prompt tempdeltafreq,"Delta Encounter Frequency"
	
	variable /g speed
	variable tempspeed = speed
	prompt tempspeed, "Speed (Knots)"
	
	variable /g heading
	variable tempheading = heading
	prompt tempheading, "Heading (0 Degrees = Head Seas)"
	
	
	variable V_Flag
	DoPrompt "Convert Encounter to Wave Frequency",tempwname,tempdeltafreq,tempspeed,tempheading //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif
	
	wname = tempwname
	deltafreq = tempdeltafreq
	speed = tempspeed
	heading = tempheading
	
	string wavefreqname = wname + "wavefreq"
	duplicate /O $wname, $wavefreqname
	
	wave wavefreqwave = $wavefreqname
	
	variable i
	for(i=0; i < numpnts($wavefreqname); i=i+1)
		wavefreqwave[i] = i * deltafreq
	endfor
	
	variable v = speed*6076/3600
	variable g = 32.18
	variable theta = heading /(180/pi)
	for(i=0; i < numpnts($wavefreqname); i=i+1)
		wavefreqwave[i] = (-1+ (1+4*v*cos(theta)/g*wavefreqwave[i])^0.5 ) / (2*v*cos(theta)/g)
	endfor

end









