//functions are faster than macros
//functions can be inserted into the macros menu
//Proc procedures can use global wave names directly
//proc are macros that do not show up in the menu by default










//http://www.vishay.com/docs/11065/_vmr-tc0.pdf
//page 5, equations 3, 4, and 5
//for 0, 45, 90 rectangular gauges
function rosette()

	string /g wave0deg
	string tempwave0deg = wave0deg
	prompt tempwave0deg,"Wave 0 Degrees",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	variable /g wave0offset
	variable tempwave0offset = wave0offset
	prompt tempwave0offset,"Wave 0 Offset"
	
	string /g wave45deg
	string tempwave45deg = wave45deg
	prompt tempwave45deg,"Wave 45 Degrees",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	variable /g wave45offset
	variable tempwave45offset = wave45offset
	prompt tempwave45offset,"Wave 45 Offset"

	string /g wave90deg
	string tempwave90deg = wave90deg
	Prompt tempwave90deg,"Wave 90 Degrees",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	variable /g wave90offset
	variable tempwave90offset = wave90offset
	prompt tempwave90offset,"Wave 90 Offset"
	
	variable /g scalefactor
	variable tempscalefactor = scalefactor
	Prompt tempscalefactor,"Scale Factor for Principle Magnitude"
	
	string /g subtractmean //stores the selected filter type
	string tempsubtractmean = subtractmean
	Prompt tempsubtractmean,"Subtract Offset or Mean of Each Wave?", popup, "offset;mean"
		
	//prompt the user for inputs
	variable V_Flag
	DoPrompt "Rosette Analysis - Rectangular 0,45,90 Gauge",tempwave0deg,tempwave0offset,tempwave45deg,tempwave45offset,tempwave90deg,tempwave90offset,tempscalefactor,tempsubtractmean //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif

	wave0deg = tempwave0deg
	wave0offset = tempwave0offset
	wave45deg = tempwave45deg
	wave45offset = tempwave45offset
	wave90deg = tempwave90deg
	wave90offset = tempwave90offset
	scalefactor = tempscalefactor
	subtractmean = tempsubtractmean

	variable w0mean = mean($wave0deg)
	wave w0deg = $wave0deg
	variable w45mean = mean($wave45deg)
	wave w45deg = $wave45deg
	variable w90mean = mean($wave90deg)
	wave w90deg = $wave90deg
	//subtract the mean of each wave?
	if(stringmatch(subtractmean,"mean"))
		w0deg = w0deg - w0mean
		w45deg = w45deg - w45mean
		w90deg = w90deg - w90mean
	else
		w0deg = w0deg - wave0offset
		w45deg = w45deg - wave45offset
		w90deg = w90deg - wave90offset
	endif
		
	//duplicate 1 wave to store output
	string strainPQplus = wave0deg + "-EPQplus"
	string strainPQminus = wave0deg + "-EPQminus"
	string thetaPQ = wave0deg + "-thetaPQ"
	duplicate/O w0deg $thetaPQ, $strainPQminus, $strainPQplus
	wave wEPQplus = $strainPQplus
	wave wEPQminus = $strainPQminus
	wave wThetaPQ = $thetaPQ
	
	//step through waves and evaluate equations
	variable sqrt2 = sqrt(2)
	wEPQplus = (w0deg+w90deg)/2 + 1/sqrt2*sqrt( (w0deg-w45deg)^2  +  (w45deg-w90deg)^2  )
	wEPQplus = wEPQplus * scalefactor
	wEPQminus = (w0deg+w90deg)/2 - 1/sqrt2*sqrt( (w0deg-w45deg)^2  +  (w45deg-w90deg)^2  )
	wEPQminus = wEPQminus * scalefactor
	//wThetaPQ = 1/2 * atan(  (2*w45deg-w0deg+w90deg)  /  (w0deg-w90deg)   )
	
	
	
	//handle angle oddities
	variable p=0,Tangent = 0,npts=numpnts(w0deg)	//Common calculation used to clean up program
	do	// execute the loop body
		Tangent = 28.6479 *atan2(((2 * w45deg[p]) - w0deg[p] - w90deg[p]), (w0deg[p] - w90deg[p]))//Calc of common variable
		if (w0deg[p] == w90deg[p])			// command
			wThetaPQ[p] = 45			// execute if condition is TRUE
		else					// execute if condition is FALSE
			if ((Tangent) < 0)			      
			 	wThetaPQ[p] = 180 + Tangent						// execute if condition is TRUE
			else
				wThetaPQ[p] = Tangent							// execute if condition is FALSE
			endif
		endif
		p += 1
	while (p < npts)
	
	

	//add the mean of the input waves back in?
	if(stringmatch(subtractmean,"mean"))
		w0deg = w0deg + w0mean
		w45deg = w45deg + w45mean
		w90deg = w90deg + w90mean
	else
		w0deg = w0deg + wave0offset
		w45deg = w45deg + wave45offset
		w90deg = w90deg + wave90offset
	endif
		
	//display original wave and filtered wave
	//Display $wave0deg,$wave45deg,$wave90deg
	//ModifyGraph rgb($wave0deg)=(0,12800,52224)
	//Legend/C/N=text0/A=MC
	
end // rosette






