#pragma rtGlobals=1		// Use modern global access method.





function twopweibull()

	variable betalowerbound
	variable tempbetalowerbound = betalowerbound
	if(tempbetalowerbound == 0)
		tempbetalowerbound = 0.1
	endif
	prompt tempbetalowerbound,"Beta Lower Bound"
	
	variable betaupperbound
	variable tempbetaupperbound = betaupperbound
	if(tempbetaupperbound == 0)
		tempbetaupperbound = 10
	endif
	prompt tempbetaupperbound,"Beta Upper Bound"
	
	variable betastep
	variable tempbetastep = betastep
	if(tempbetastep == 0)
		tempbetastep = 0.001
	endif
	prompt tempbetastep,"Beta Step"


	String wname //stores the selected wave name
	wname = "amplitudes"
	string tempwname = wname
	Prompt tempwname,"Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	variable V_Flag
	DoPrompt "2 Parameter Weibull Analysis",tempwname,tempbetalowerbound,tempbetaupperbound,tempbetastep //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif

	wname = tempwname
	betalowerbound = tempbetalowerbound
	betaupperbound = tempbetaupperbound
	betastep = tempbetastep


	wave waveref = $wname


	variable numamplitudes = numpnts(waveref) //get the number of amplitudes from the selected wave
	
	string sortedamplitudeswave = "sortedamplitudes"
	duplicate /O $wname, $sortedamplitudeswave
	wave sortedamplitudes = $sortedamplitudeswave

	//some amplitudes must have mean subtracted
	string amplitudetype
	variable wmean
	variable i
	if(stringmatch(amplitudetype,"mean crossing max"))
		for(i=0;i< numamplitudes;i=i+1)
			sortedamplitudes[i] = sortedamplitudes[i] - wmean
		endfor
	elseif(stringmatch(amplitudetype,"mean crossing min"))
		for(i=0;i< numamplitudes;i=i+1)
			sortedamplitudes[i] = sortedamplitudes[i] - wmean
		endfor
	endif
	//make sure all amplitudes are positive
	for(i=0;i< numamplitudes;i=i+1)
		sortedamplitudes[i] = abs(sortedamplitudes[i])
	endfor


	variable ampmean
	ampmean = mean(sortedamplitudes,0,numamplitudes-1) //get the mean of the selected amplitudes
	variable ampvariance
	variable V_sdev
	variable V_max
	variable V_min
	wavestats sortedamplitudes
	ampvariance = V_sdev*V_sdev
	variable ampmax = V_max
	variable ampmin = V_min
	print ampvariance

	
	//sort amplitudes in ascending order
	sort sortedamplitudes, sortedamplitudes
	
	//created ordered index for each amplitude
	string sortedamplitudesindexwave = "sortedamplitudesindex"
	make /O/N=(numamplitudes) $sortedamplitudesindexwave
	wave sortedamplitudesindex = $sortedamplitudesindexwave
	
	//calculate the index
	for(i=0;i< numamplitudes;i=i+1)
		sortedamplitudesindex[i] = i+1
	endfor
	
	//duplicate the waves again
	string weibullxwave = "weibullx"
	duplicate /O $sortedamplitudesindexwave, $weibullxwave
	wave weibullx = $weibullxwave

	string weibullywave = "weibully"
	duplicate /O $sortedamplitudeswave, $weibullywave
	wave weibully = $weibullywave
	


	//linearize the weibull data
	variable dataval = 0
	for(i=0;i< numamplitudes;i=i+1)
		weibullx[i] = ln(sortedamplitudes[i])
		weibully[i] = ln( ln( 1/(1-((i+1)/(numamplitudes+1)) ) ) )
	endfor
	
	string weibullylinregwave = "weibullylinreg"
	duplicate /O $weibullywave, $weibullylinregwave
	wave weibullylinreg = $weibullylinregwave

	//linear regression
	variable V_Pr
	curvefit line weibully /X=weibullx /D=weibullylinreg
	variable linregcorrelationr
	linregcorrelationr = V_Pr
	
	string wcoefwave = "W_coef"
	wave wcoef = $wcoefwave
	variable linregcharval = exp(-wcoef[0]/wcoef[1])
	variable linregbeta = wcoef[1]
	variable linregyint = wcoef[0]




	/////////////////////////////
	//calculate moment method beta
	/////////////////////////////
	variable VarianceDivMeanSq;
	variable mmbeta;
		
	//maxes
	VarianceDivMeanSq = ampvariance/(ampmean*ampmean);
	print variancedivmeansq
	mmbeta = BetaLowerBound;//random start/init value
	variable b
	for(b=BetaLowerBound; b <= BetaUpperBound; b=b+BetaStep)
			if( Abs(exp(gammln(1+2/b)/(exp(gammln(1+1/b))*exp(gammln(1+1/b))) - 1) - VarianceDivMeanSq) < Abs(exp(gammln(1+2/mmbeta)/(exp(gammln(1+1/mmbeta))*exp(gammln(1+1/mmbeta))) - 1) - VarianceDivMeanSq) )
				mmbeta = b
			endif

	endfor
	

	//calculate the moment method lines
	//and y intercepts
	variable mmcharval
	variable mmyint
	mmcharval = ampmean/exp(gammln(1+1/mmbeta));
	mmyint = -mmbeta*ln(Abs(mmcharval));
	
	print mmbeta
	

	//computes the resultant moment method line
	string weibullymomentmethodwave = "weibullymomentmethod"
	duplicate /O $weibullywave, $weibullymomentmethodwave
	wave weibullymomentmethod = $weibullymomentmethodwave
	
	for(i=0; i < numamplitudes; i=i+1)
		weibullymomentmethod[i] = mmbeta*weibullx[i]+mmyint;
	endfor
	
	
	
	
	
	//display graph of result
	display weibully, weibullylinreg, weibullymomentmethod vs weibullx as "TwoParameterWeibull"
	ModifyGraph rgb(weibully)=(0,12800,52224)
	ModifyGraph rgb(weibullymomentmethod)=(0,65280,0)
	Legend/C/N=text0/A=MC
	Label left "ln(ln(1/(1-P))"
	Label bottom "ln(x)"
	TextBox/C/N=text1/A=MC "Weibull Statistics"
	appendtext "linregbeta: " + num2str(linregbeta)
	appendtext "linregyint: " + num2str(linregyint)
	appendtext "linregcharval: " + num2str(linregcharval)
	appendtext "linregcorrelationr: " + num2str(linregcorrelationr)
	appendtext "mmbeta: " + num2str(mmbeta)
	appendtext "mmyint: " + num2str(mmyint)
	appendtext "mmcharval: " + num2str(mmcharval)
	appendtext "numamplitudes: " + num2str(numamplitudes)
	appendtext "ampmean: " + num2str(ampmean)
	appendtext "ampmax: " + num2str(ampmax)
	appendtext "ampmin: " + num2str(ampmin)
	appendtext "ampvariance: " + num2str(ampvariance)





end









function twopweibullorig()

	variable /g betalowerbound
	variable tempbetalowerbound = betalowerbound
	if(tempbetalowerbound == 0)
		tempbetalowerbound = 0.1
	endif
	prompt tempbetalowerbound,"Beta Lower Bound"
	
	variable /g betaupperbound
	variable tempbetaupperbound = betaupperbound
	if(tempbetaupperbound == 0)
		tempbetaupperbound = 10
	endif
	prompt tempbetaupperbound,"Beta Upper Bound"
	
	variable /g betastep
	variable tempbetastep = betastep
	if(tempbetastep == 0)
		tempbetastep = 0.001
	endif
	prompt tempbetastep,"Beta Step"


	String /g wname //stores the selected wave name
	wname = "amplitudes"
	string tempwname = wname
	Prompt tempwname,"Wave",popup,WaveList("*", ";", "") //promps from waves in the working data folder
	variable V_Flag
	DoPrompt "2 Parameter Weibull Analysis",tempwname,tempbetalowerbound,tempbetaupperbound,tempbetastep //creates the prompt window
	if (V_Flag)
		print "cancelled"
		return 0	// check if user canceled
	endif

	wname = tempwname
	betalowerbound = tempbetalowerbound
	betaupperbound = tempbetaupperbound
	betastep = tempbetastep


	wave waveref = $wname


	variable /g numamplitudes = numpnts(waveref) //get the number of amplitudes from the selected wave
	
	string sortedamplitudeswave = "sortedamplitudes"
	duplicate /O $wname, $sortedamplitudeswave
	wave sortedamplitudes = $sortedamplitudeswave

	//some amplitudes must have mean subtracted
	string /g amplitudetype
	variable /g wmean
	variable i
	if(stringmatch(amplitudetype,"mean crossing max"))
		for(i=0;i< numamplitudes;i=i+1)
			sortedamplitudes[i] = sortedamplitudes[i] - wmean
		endfor
	elseif(stringmatch(amplitudetype,"mean crossing min"))
		for(i=0;i< numamplitudes;i=i+1)
			sortedamplitudes[i] = sortedamplitudes[i] - wmean
		endfor
	endif
	//make sure all amplitudes are positive
	for(i=0;i< numamplitudes;i=i+1)
		sortedamplitudes[i] = abs(sortedamplitudes[i])
	endfor


	variable /g ampmean
	ampmean = mean(sortedamplitudes,0,numamplitudes-1) //get the mean of the selected amplitudes
	variable /g ampvariance
	variable V_sdev
	variable V_max
	variable V_min
	wavestats sortedamplitudes
	ampvariance = V_sdev*V_sdev
	variable /g ampmax = V_max
	variable /g ampmin = V_min
	print ampvariance

	
	//sort amplitudes in ascending order
	sort sortedamplitudes, sortedamplitudes
	
	//created ordered index for each amplitude
	string sortedamplitudesindexwave = "sortedamplitudesindex"
	make /O/N=(numamplitudes) $sortedamplitudesindexwave
	wave sortedamplitudesindex = $sortedamplitudesindexwave
	
	//calculate the index
	for(i=0;i< numamplitudes;i=i+1)
		sortedamplitudesindex[i] = i+1
	endfor
	
	//duplicate the waves again
	string weibullxwave = "weibullx"
	duplicate /O $sortedamplitudesindexwave, $weibullxwave
	wave weibullx = $weibullxwave

	string weibullywave = "weibully"
	duplicate /O $sortedamplitudeswave, $weibullywave
	wave weibully = $weibullywave
	


	//linearize the weibull data
	variable dataval = 0
	for(i=0;i< numamplitudes;i=i+1)
		weibullx[i] = ln(sortedamplitudes[i])
		weibully[i] = ln( ln( 1/(1-((i+1)/(numamplitudes+1)) ) ) )
	endfor
	
	string weibullylinregwave = "weibullylinreg"
	duplicate /O $weibullywave, $weibullylinregwave
	wave weibullylinreg = $weibullylinregwave

	//linear regression
	variable V_Pr
	curvefit line weibully /X=weibullx /D=weibullylinreg
	variable /g linregcorrelationr
	linregcorrelationr = V_Pr
	
	string wcoefwave = "W_coef"
	wave wcoef = $wcoefwave
	variable /g linregcharval = exp(-wcoef[0]/wcoef[1])
	variable /g linregbeta = wcoef[1]
	variable /g linregyint = wcoef[0]




	/////////////////////////////
	//calculate moment method beta
	/////////////////////////////
	variable VarianceDivMeanSq;
	variable /g mmbeta;
		
	//maxes
	VarianceDivMeanSq = ampvariance/(ampmean*ampmean);
	print variancedivmeansq
	mmbeta = BetaLowerBound;//random start/init value
	variable b
	for(b=BetaLowerBound; b <= BetaUpperBound; b=b+BetaStep)
			if( Abs(exp(gammln(1+2/b)/(exp(gammln(1+1/b))*exp(gammln(1+1/b))) - 1) - VarianceDivMeanSq) < Abs(exp(gammln(1+2/mmbeta)/(exp(gammln(1+1/mmbeta))*exp(gammln(1+1/mmbeta))) - 1) - VarianceDivMeanSq) )
				mmbeta = b
			endif

	endfor
	

	//calculate the moment method lines
	//and y intercepts
	variable /g mmcharval
	variable /g mmyint
	mmcharval = ampmean/exp(gammln(1+1/mmbeta));
	mmyint = -mmbeta*ln(Abs(mmcharval));
	
	print mmbeta
	

	//computes the resultant moment method line
	string weibullymomentmethodwave = "weibullymomentmethod"
	duplicate /O $weibullywave, $weibullymomentmethodwave
	wave weibullymomentmethod = $weibullymomentmethodwave
	
	for(i=0; i < numamplitudes; i=i+1)
		weibullymomentmethod[i] = mmbeta*weibullx[i]+mmyint;
	endfor
	
	
	
	
	
	//display graph of result
	display weibully, weibullylinreg, weibullymomentmethod vs weibullx as "TwoParameterWeibull"
	ModifyGraph rgb(weibully)=(0,12800,52224)
	ModifyGraph rgb(weibullymomentmethod)=(0,65280,0)
	Legend/C/N=text0/A=MC
	Label left "ln(ln(1/(1-P))"
	Label bottom "ln(x)"
	TextBox/C/N=text1/A=MC "Weibull Statistics"
	appendtext "linregbeta: " + num2str(linregbeta)
	appendtext "linregyint: " + num2str(linregyint)
	appendtext "linregcharval: " + num2str(linregcharval)
	appendtext "linregcorrelationr: " + num2str(linregcorrelationr)
	appendtext "mmbeta: " + num2str(mmbeta)
	appendtext "mmyint: " + num2str(mmyint)
	appendtext "mmcharval: " + num2str(mmcharval)
	appendtext "numamplitudes: " + num2str(numamplitudes)
	appendtext "ampmean: " + num2str(ampmean)
	appendtext "ampmax: " + num2str(ampmax)
	appendtext "ampmin: " + num2str(ampmin)
	appendtext "ampvariance: " + num2str(ampvariance)





end













//***********************************************************************************************************************
//	Function InitializeProgram()
//		Determines from the user if the data speed is slow, medium, or fast. 
//		It also sets the density ratio to multiply the data by.
Function InitializeProgram()
	
	String/G extension = ".scl", DoConcatenate = "No"
	String fastslow, fileType = extension, concatenate
	Variable/G root:speed, root:numChannelsPerRun, numAnalysisChannelsPerRun, root:frequency, DR=1//DR = 64 / 62.42		// DR = density ratio
	NVAR speed=root:speed, numChannelsPerRun=root:numChannelsPerRun, frequency=root:frequency
	Variable ratio = DR
	Variable freqFast = 2000, freqSlow = 100//, freqMed = 5000
	Variable numChannelsFast = 10, numChannelsSlow = 79//, numChannelsMed = 8
	
	Prompt freqFast, "Acquisition frequency of fast data (Hz)"
//	Prompt freqMed, "Acquisition frequency of medium data (Hz)"
	Prompt freqSlow, "Acquisition frequency of slow data (Hz)"
	Prompt numChannelsFast, "Number of channels for fast data. DON'T INLCUDE TIME TAG"
//	Prompt numChannelsMed, "Number of channels for medium data"
	Prompt numChannelsSlow, "Number of channels for slow data"
	DoPrompt "Set Data Acquisition Information", freqFast, numChannelsFast, freqSlow, numChannelsSlow//, freqMed, numChannelsMed
	
//	Prompt fastslow, "Select type/speed of data to analyze:", popup, "Fast;Medium;Slow"
	Prompt fastslow, "Select type/speed of data to analyze (Slow - FastEvent - Fast):", popup, "Slow;FastEvent;Fast"
	Prompt fileType, "Enter file extension in quotes. ie. binary=\".scl\", text=\".txt\""
	Prompt ratio, "Set Density Ratio. Current ratio is 64/62.42. If incorporated into data, enter 1."
	DoPrompt "Initialize Program", fastslow, fileType, ratio
	
	Prompt concatenate, "Do the data runs need to be concatenated?", popup, "No;Yes"
	DoPrompt "Concatenate data runs?", concatenate
		
	if (stringmatch(fastslow, "Slow") == 1)
		speed = 0						// User chose slow.
		frequency = 1/freqSlow
		numChannelsPerRun = numChannelsSlow
		numAnalysisChannelsPerRun = numChannelsPerRun
	else
		if (stringmatch(fastslow, "Fast") == 1)
			speed = 1						// User chose fast.
			frequency = 1/freqFast
			numChannelsPerRun = numChannelsFast
			numAnalysisChannelsPerRun = numChannelsPerRun
		else
			if (stringmatch(fastslow, "FastEvent") == 1)
				speed = 1						// User chose fast event.
				frequency = 1/freqFast
				numChannelsPerRun = numChannelsFast + 1
				numAnalysisChannelsPerRun = numChannelsFast
			else
//				speed = 2					// User chose medium.
//				frequency = 1/freqMed
//				numChannelsPerRun = numChannelsMed
//				numAnalysisChannelsPerRun = numChannelsPerRun
			endif
		endif
	endif
	DR = ratio
	extension = fileType
	DoConcatenate = concatenate
End
//*****End of Function InitializeProgram







//***********************************************************************************************************************
//	Function ChooseToDisplayOrSupressGraphs()
//		Determines whether or not to display graphs in the Impact Peaks and Weibull procedures.
Function ChooseToDisplayOrSupressGraphs()

	String answer
	Prompt answer, "Display or supress graphing. DO NOT DISPLAY WHEN DOING MANY GRAPHS.", popup, "supress;display"
	DoPrompt "Display or supress graphing", answer
	
	Variable/G root:graph = 0
	NVAR graph = root:graph
	If (stringmatch(answer, "supress") == 1)
		graph = 0
	else
		graph = 1
	Endif
End
//*****End of Function ChooseToDisplayOrSupressGraphs










//***********************************************************************************************************************
//	Function SecondZeroAxis(list)
// 		This function re-zeros the axis 
Function SecondZeroAxis(list)
	String list
	String TheWave
	Variable tbegin, tend
	Variable index=0
       
	Do
		// get the next wave name
		TheWave = GetStrFromList(list, index, ";")
		WAVE currentWave = $TheWave
      
		if (strlen(TheWave)==0)
			break
		else
//			duplicate/O currentWave tempsort
//			sort currentWave tempsort
//			wavestats/Q/R=[0,trunc(numpnts(tempsort)*2/3)] tempsort
//			currentWave = currentWave - V_avg
			
			Wave currentWave = $TheWave
			WaveStats/Q currentWave
			currentWave = currentWave - V_avg
			index += 1
		endif
//		index += 1
	while (1)					// as long as condition is true
End
//*****End of Function SecondZeroAxis














//***********************************************************************************************************************
//	Proc LoadDataSetsFromFolder(pathName)
//		Loads data from all the files of the user-specified file type and speed in the folder associated with 
//		the specified symbolic path. 
//		pathName is the name of an IGOR symbolic path which you can create with the New Path
//		dialog in the Misc menu.
//		If pathName is "", it puts up a dialog from which you can choose the folder.
//
//		NOTE: If files are not loading in numeric order, it has to do with the order in which they were placed 
//		into the folder. It may be necessary for the user to re-place each file into the folder in the order desired.
Proc LoadDataSetsFromFolder(pathName)
	String pathName			// Name of an existing IGOR symbolic path or ""

	// These are for removing NANs
	String BadWaveStr
	Variable index = 0

	// If pathName is "", allow user to create a new symbolic path to the folder containing the runs of data.
	if (strlen(pathName) == 0)
		NewPath/O/Q/M="Choose folder containing data files" CurrentDataFilePath
		PathInfo CurrentDataFilePath					// Check to see if user created the path.
		if (V_flag == 0)
			return -1									// User cancelled.
		endif
		pathName = "CurrentDataFilePath"
	endif

	Variable/G Weibullindex = 0, numRunsLoaded = 0, threshold=0, difftweek=0
	Variable totalChannels = 0, i = 0					// "i" represents the Run # from a data Set.
	String fileName
	String savedDataFolder = GetDataFolder(1)			// Save the current data folder so we can restore it below.

	do
		fileName = IndexedFile($pathName, i, root:extension)	// "????" loads ALL files in the folder. See IndexedFile help for details.
		if (strlen(fileName) == 0)
			break
		endif
		
//		do
//			if (root:speed == 0)	// Slow
//				If (stringmatch(fileName,"*Slow*") == 0)
//					break
//				EndIf
//			else
//				if (root:speed == 1)	// Fast
//					If (stringmatch(fileName,"*Fast*") == 0)
//						break
//					EndIf
//				else		// Medium
//					If (stringmatch(fileName,"*Med*") == 0)
//						break
//					EndIf
//				endif
//			endif
			
			// If it does not already exist, make a data folder to contain the waves from the file.
			// The new data folder is created in the current data folder with the name the
			// same as the name of the file we are about to load.
			// The /S flag sets new data folder as the current data folder.
			NewDataFolder/O/S root:$fileName
			
			// This loads binary data from HSS trials into the current IGOR data folder
			// which is the data folder we just created above.
			GBLoadWave/V/T={2,2}/S=((root:numAnalysisChannelsPerRun+1)*8)/W=(root:numChannelsPerRun)/P=$pathName fileName	// for fast event files

			//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!		
			// Remove the NANs
			// check the first wave of those you just loaded to see if there are any NANs and DELETE
			wavestats/Q wave0
			if (V_numNaNs > 0)
				do
					BadWaveStr = GetIndexedObjName(":", 1, index)
					if (strlen(BadWaveStr) == 0)
						break
					endif
					RemoveNaNs($BadWaveStr)
					index += 1
				while (1)
			endif
			//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
			// Set waves' X and Y scaling and units.
			SetWaveUnits(root:speed)

			// Zero the axis of the wave in case there is some offset.
			ZeroAxis()
			
			If (stringmatch(root:DoConcatenate,"No") == 1)
				// Calculate the total length of the run
				// Rename the data file channels
				Duration = numpnts(wave0) * root:frequency// * sqrt(45)		// * sqrt(45) for full scale time from model scale
				if (root:speed == 0)
					HSV2slowRenameScale()
				else
					if (root:speed == 1)
						HSV2FASTRenameScale()
					else
//						HSSmediumRenameScale()
					endif
				endif
				// Get the following parameters from the wave and present them in a table:
				// tMean,tMin,tMax,MinMean,MaxMean,tRange,tStdDev,TheSkew, TheKertosis
				WaveStatList (WaveList("*",";",""), fileName)

				// Create a folder to store the parameters and results of Impact peaks for future use.
				NewDataFolder/O/S Results
//				NewDataFolder/O/S root:$(GetDataFolder(0)):Results
				Make/O/T IPparams = {"thresh","tmin","tmax","tweek","minSearch","washCheck","newSearchMin","minDelta","preDiffSmooth", "postDiffSmooth"}
				Make/O/T WhParams = {"tmin","tmax","trig","WhipRatio","look","int","width","dt","ratio"}
				string/G existingWaves
	
				// Restore the original data folder.
				SetDataFolder savedDataFolder
			EndIf
//		while(1)
		i += 1
	while (1)

	// Restore the original data folder.
	SetDataFolder savedDataFolder
	numRunsLoaded = i
	totalChannels = numRunsLoaded * root:numAnalysisChannelsPerRun

	If (stringmatch(root:DoConcatenate,"Yes") == 1)
		if (numRunsLoaded > 1)
			ConcatenateWavesInFolders(numRunsLoaded)
		endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This portion of code is for concatenating data of the same condition stored in different folders.
// Comment out when running program "normally". 1/28/03
//	NewPath/O/Q/M="Choose folder containing data files" CurrentDataFilePath
//	PathInfo CurrentDataFilePath					// Check to see if user created the path.
//	if (V_flag == 0)
//		return -1									// User cancelled.
//	endif
//	pathName = "CurrentDataFilePath"
//	savedDataFolder = GetDataFolder(1)
//	i =0
//	do
//		fileName = IndexedFile($pathName, i, "????")	// This loads ALL files in the folder. See IndexedFile help for details.
//		if (strlen(fileName) == 0)
//			break
//		endif
//		NewDataFolder/O/S root:$fileName
//		GBLoadWave/V/T={2,2}/S=((root:numChannelsPerRun+1)*8)/W=(root:numChannelsPerRun)/P=$pathName fileName
//		SetWaveUnits(root:speed)
//		ZeroAxis()
//		i += 1
//	while (1)
	// Restore the original data folder.
//	SetDataFolder savedDataFolder
//	numRunsLoaded = numRunsLoaded+i
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	// Calculate the total length of the run
	// Rename the data file channels
	SetDataFolder $GetIndexedObjName(":", 4, 0)
	Duration = numpnts(wave0) * root:frequency// * sqrt(45)		// * sqrt(45) for full scale time from model scale
	if (root:speed == 0)
		HSV2slowRenameScale()
		RenameDataFolder $GetIndexedObjName(":", 4, 0), SlowData
	else
		if (root:speed == 1)
			HSV2FASTRenameScale()
			RenameDataFolder $GetIndexedObjName(":", 4, 0), FastData
		else
//			HSSmediumRenameScale()
//			RenameDataFolder $GetIndexedObjName(":", 4, 0), HSS_Med
		endif
	endif
	
	// Zero the axis a second time since we still have offset due to the nature of the data.
//	SecondZeroAxis(WaveList("*",";",""))
	
	// Get the following parameters from the wave and present them in a table:
	// tMean,tMin,tMax,MinMean,MaxMean,tRange,tStdDev,TheSkew, TheKertosis
	WaveStatList (WaveList("*",";",""),fileName)

	// Create a folder to store the parameters and results of Impact peaks for future use.
	NewDataFolder/O/S root:$(GetDataFolder(0)):Results
	Make/O/T IPparams = {"thresh","tmin","tmax","tweek","minSearch","washCheck","newSearchMin","minDelta"}
	Make/O/T WhParams = {"tmin","tmax","trig","WhipRatio","look","int","width","dt","ratio"}
	string/G existingWaves
	
	// Restore the original data folder.
	SetDataFolder savedDataFolder	

	EndIf

	// Create waves to hold the Weibull and population statistics
	Make/O/T/N=(totalChannels) SetRun, ChannelName
	Make/O/D/N=(totalChannels) Wcorr, Wslope, Wintercept, Wx0, Wchv, WPmax, Wmin, Wmax, Wavg, WstdDev, Wimpacts, WimpactsPerHour

//	// Create waves to hold the Weibull and population statistics.  Multiply the number of channels by 10 since there are 10 possible waves to do Weibull analysis on.
//	Make/O/T/N=(10*numChannelsPerRun) SetRun, ChannelName
//	Make/O/D/N=(10*numChannelsPerRun) Wcorr, Wslope, Wintercept, Wx0, Wchv, WPmax, Wmin, Wmax, Wavg, WstdDev, Wimpacts, WimpactsPerHour
End
//*****End of Proc LoadDataSetsFromFolder














//***********************************************************************************************************************
//	Function ConcatenateWavesInFolders(numRunsLoaded)
//		Concatenate the waves in each of the "runs" for HSS data.
Function ConcatenateWavesInFolders(numRunsLoaded)
	Variable numRunsLoaded

	Variable tmp = 1, channelindex=0, i
	String workFolder, channel, getFolder, channel3
	NVAR numChannelsPerRun = root:numChannelsPerRun, speed = root:speed
	SVAR savedDataFolder = root:savedDataFolder
	
	workFolder = GetIndexedObjName("", 4, 0)
	do
		SetDataFolder savedDataFolder
		getFolder = GetIndexedObjName("",4,tmp)
		SetDataFolder workFolder
		do
			channel = NameOfWave(WaveRefIndexed("", channelindex, 4))
			SetDataFolder root:$getFolder
			Duplicate/O WaveRefIndexed("", channelindex, 4) tmpWave
			MoveWave tmpWave, root:$(workFolder):tempWave
			SetDataFolder root:$workFolder
			channel3 = NameOfWave(tmpWave)
			ConcatenateWaves(channel,channel3)
			KillWaves tempWave
			channelindex += 1
		while (channelindex < numChannelsPerRun)
		tmp += 1
		channelindex = 0
	while (tmp < numRunsLoaded)
	
	SetDataFolder savedDataFolder

	// Kill all the folders we used for concatenating waves except the folder we stored waves in
	for (i=1; i<numRunsLoaded; i+=1)
		String nextPath = GetIndexedObjName(":", 4, 1)
		KillDataFolder nextPath
	endfor
End
//*****End of Function ConcatenateWavesInFolders







//***********************************************************************************************************************
//	Function SetWaveUnits(speedval)
//		Sets the X units and data units for ALL of the waves in the current data folder.
//		This is intended for use immediately after loading a set of waves into a new data folder.
Function SetWaveUnits(speedval)
	Variable speedval

	String waveNameStr
	Variable i = 0
	NVAR frequency = root:frequency
	Variable/G Duration
		
	do 
		waveNameStr = GetIndexedObjName(":", 1, i)
		if (strlen(waveNameStr) == 0)
			break
		endif
		Wave w = $waveNameStr
		
		SetScale/P x, 0, frequency, "sec", w			// Set X units to appropriate number 
															// (10 ms per point for HSV2 Slow,  0.5 ms per point for HSV2 Fast)
//		SetScale/P x, 0, (frequency * sqrt(45)), "sec", w			// Normally model scale (* sqrt(45) for full scale).
		SetScale d, 0, 0, "microstrain", w					// Set data units to microstrain.
		i += 1
	while (1)
End
//*****End of Function SetWaveUnits






//***********************************************************************************************************************
// 	Function ZeroAxis()
//		Zeros the data for ALL of the waves in the current data folder in case of any offset.
//		This is intended for use immediately after loading a set of waves into a new data folder.
Function ZeroAxis()
	String waveNameStr
	Variable i = 0
	NVAR speed=root:speed
	
////	WAVE baseline = root:baseline
	do
		waveNameStr = GetIndexedObjName(":", 1, i)
		If (strlen(waveNameStr) == 0)
			break
		EndIf
		Wave w = $waveNameStr

		// Use this for slow data
		If (speed == 0)
			WaveStats/Q w
			w = w - V_avg
//			baseline[i] = V_avg
//			w = w - baseline[i] // + abs(w - baseline[i])
			i += 1
//	while (1)

		// Use this  for fast and medium data
		// This assumes that most of the data is at the baseline value.
		Else
			duplicate/O w tempsort
			sort w tempsort
			wavestats/Q/R=[0,trunc(numpnts(tempsort)*2/3)] tempsort
			w = w - V_avg
			i += 1
			KillWaves tempsort
		EndIf
	while (1)					// as long as condition is true
End
//*****End of Function ZeroAxis











//***********************************************************************************************************************
//	Function UpdateGraph(R, x0, slope, scaleFactor, Intercept, avg, minimum, maximum, stdDev, mostProbMax, 
// 	numPts, channel)
//		This function updates an existing graph by adding the channel analyzed, date and parameters found.
Function UpdateGraph(R, x0, slope, scaleFactor, Intercept, avg, minimum, maximum, stdDev, mostProbMax, numPts, channel)
	Variable R, x0, slope, scaleFactor, Intercept, avg, minimum, maximum, stdDev, mostProbMax, numPts
	String channel
	
	String results, namedate
	sprintf results, "Three Parameter Est:\r R=%g\r x\\B0\\M=%g\r Slope=%g\r Scale Factor=%g\r Intercept=%g\r Mean=%g\r Min=%g\r Max=%g\r Std Dev=%g\r Most Prob Max=%g\r No Pts=%g", R, x0, slope, scaleFactor, Intercept, avg, minimum, maximum, stdDev, mostProbMax, numPts
	sprintf namedate, "%s\r %s", channel, date()
	Textbox/C/N=text3 /A=RB results
	Textbox/C/N=text4/F=0/E/A=MB namedate
End
//*****End of Function UpdateGraph












//***********************************************************************************************************************
//	Function determineWorkFolder(allAnalysis)
//		Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
Function/S determineWorkFolder(allAnalysis)
	Variable allAnalysis
	
	Variable folderIndex = 0, numFoldersInRoot = 0
	String gotoFolderName = "", folderList = ""
	
	SetDataFolder root:
	numFoldersInRoot = CountObjects("root:",4)
	If (numFoldersInRoot == 1)
		gotoFolderName = GetIndexedObjName("root:",4,folderIndex)
		folderList = gotoFolderName
		SetDataFolder gotoFolderName
	Else
		do
//			folderList = folderList + GetIndexedObjName("root:",4,folderIndex) + ";"		// old brute-force method
			folderList = AddListItem(GetIndexedObjName("root:",4,folderIndex),folderList,";",Inf)
			folderIndex += 1
		while (folderIndex < numFoldersInRoot)
		If(allAnalysis == 0)
			Prompt gotoFolderName, "Choose the data set to work on", popup, folderList
			DoPrompt "Choose folder", gotoFolderName
			If (V_flag != 0)										// User cancelled
				SetDataFolder root:
				return ""
			EndIf
			SetDataFolder gotoFolderName
		EndIf
	EndIf
//	SetDataFolder gotoFolderName
	return folderList
End
//*****End of Function determineWorkFolder()








































//
//
//***********************************************************************************************************************
//	Proc DoImpactPeaks(w, thresh, tmin, tmax, tweek, minSearch, washCheck, newSearchMin, minDelta)
//		This procedure finds the impact peaks of the fast data for the current data folder
Function DoImpactPeaks(w, thresh, tmin, tmax, tweek, minSearch, washCheck, newSearchMin, minDelta, preDiffSmooth, postDiffSmooth)
	String w
	Variable thresh
	Variable tmin
	Variable tmax
	Variable tweek
	Variable minSearch
	Variable washCheck
	Variable newSearchMin
	Variable minDelta
	Variable preDiffSmooth
	Variable postDiffSmooth
	
	SVAR existingWaves = :Results:existingWaves

	If (exists("root:graph") == 0)
		Abort "First choose if you wish to display graphs!"
	EndIf

	Variable i=0, j=0, k=0, L=0, M=0, t1, t2, lim, t3, t4, Amp, oldtime1, oldtime2, oldtime3, t5, start=0, timeAfterPeak, peak=0, minPeak=0
	Variable/G IPnumPnts
	String initialDF = GetDataFolder(1)
	Make/O W_FindLevels
	NVAR/Z graph = root:graph
	
	Silent 1; PauseUpdate
	Duplicate/o $w  AnalysisWave
	Duplicate/o $w DiffPkwave
	Smooth/E=2/B preDiffSmooth, DiffPkwave
//	Smooth/E=2/B 3001, DiffPkwave
	Differentiate DiffPkwave
	//Smooth/E=2 1000,DiffPkwave
	//Smooth/E=2/S=4 25, DiffPkwave
	Smooth/E=2/B 5, AnalysisWave
//	Smooth/E=2/B 1001, DiffPkwave
	Smooth/E=2/B postDiffSmooth, DiffPkwave
	FindLevels/D=W_FindLevels/Q/R=(tmin,tmax) DiffPkwave, tweek			// Find time of tweek level crossings
	lim = trunc(V_LevelsFound/2)         // There will be about half as many peaks as zero crossings found - if not enough, make tweek larger
	Make/D/O/N=(lim) DiffPk2PK, DiffPkmin, DiffPkmintime, DiffPkmax, DiffPkmaxtime, halftime  // Make a wave peak output wave

	if (i == 0)										// In case the first level found is on a negative slope, start with the next
		if ((DiffPkwave(W_FindLevels[0]+0.03) - DiffPkwave(W_FindLevels[0]-0.03)) / ((W_FindLevels[0]+0.03)-(W_FindLevels[0]-0.03)) < 0)
			i = 1
		endif
	endif

	// Loop over tweek value crossings
	do
		t1 = W_FindLevels[i]            					// Pick out time for one cycle			
		t2 = W_FindLevels[i+1]		
		
		// Find peak in DiffPkwave between t1 and t2 time periods
		WaveStats/Q/R=(t1,t2)  DiffPkwave
		if (V_max > tweek)
			DiffPkmax[j] = V_max
			DiffPkmaxtime[j] = V_maxloc
			t1 = W_FindLevels[i+1]            					// Pick out time for one cycle to find min in DiffPkwave
			t2 = W_FindLevels[i+2]
			WaveStats/Q/R=(t1,t2)  DiffPkwave
			DiffPkmin[j] = V_min
			DiffPkmintime[j] = V_minloc
			DiffPk2PK[j] = DiffPkmax[j] - DiffPkmin[j]				// Form a peak to peak entry
			halftime[j] = abs(DiffPkmintime[j] - DiffPkmaxtime[j])		// half of the time from the max in DiffPkwave to the min after a peak
			j += 1									// j is the # of peaks in DiffPkwave above tweek value
		endif
		i += 2										// Execute outer loop by two
		k = k+1
	while (k < lim)									// As long as condition is true while (i<V_LevelsFound)????works better?

	Redimension /N=(j) DiffPk2PK,DiffPkmin,DiffPkmintime,DiffPkmax,DiffPkmaxtime,halftime 

	Make/D/O/N=(j+1) IPmin,IPmintime,IPmax,IPmaxtime  	// Make a wave peak output wave
	Make/D/O/N=(j+1) IPdeltaTime, IPdelta					// Make waves to store differences in Impact peaks
														// Size should be 1 more than peaks in DiffPkwave since
	do													// it's possible to have 1 more impact peak than # of DiffPeaks.
		if (start == 0)										// If just starting to check for Impact Peaks, 
			t3 = 0										// check before the first peak in DiffPkwave
			t4 = DiffPkmaxtime[L]
			start = 1
		else
			if ((start == 3) & (oldtime1 < t4))				// Make sure we do not loop endlessly
				t3 = oldtime1
				t4 = t4
				start = 4
			else
				if ((start == 3) & (oldtime1 > t4))			// Make sure we do not loop endlessly
					L +=1
					t3 = DiffPkmaxtime[L]
					t4 = DiffPkmaxtime[L] + 1.5*halftime[L]	//used to be just DiffPkmaxtime[L+1] You can also instead use DiffPkmaxtime[L] + DiffPkmintime[L] for an in-between range
					start = 4
				else
					if (L == (j-1))							// If we've already gone through all peaks,
						t3 = DiffPkmaxtime[L]				// Set t3 to last DiffPkmaxtime to check through the end.
						t4 = tmax
					else
						t3 = DiffPkmaxtime[L]
						t4 = DiffPkmaxtime[L] + 1.5*halftime[L]	//used to be just DiffPkmaxtime[L+1] You can also instead use DiffPkmaxtime[L] + DiffPkmintime[L] for an in-between range
					endif
				endif
			endif
		endif

		timeAfterPeak = minSearch// + 1					// Time to add to IPmaxtime to get Oldtime1
//		minPeak = minDelta - 0.1
		minPeak = minDelta - minDelta*0.33				// use 33% of minDelta
		WaveStats/Q/R=(t3,t4) AnalysisWave
		Amp = (V_max - V_min)
//		if(((Amp >= thresh) && (V_maxloc > oldtime1)) && ((V_maxloc - oldtime1) > 6))
		if ((Amp >= thresh) && (V_maxloc > oldtime1))
			IPmax[M] = V_max
			IPmaxtime[M] = V_maxloc
			t5 = V_maxloc
			WaveStats/Q/R=(t5,t5-minSearch) AnalysisWave
			IPmin[M] = V_min
			IPmintime[M] = V_minloc
			oldtime1 = IPmaxtime[M] + timeAfterPeak				// IPmax[M]+abs((IPmax[M]-V_maxloc))
			oldtime2 = IPmaxtime[M]
			IPdeltaTime[M] = IPmaxtime[M] - IPmintime[M]
			IPdelta[M] = IPmax[M] - IPmin[M]						// Form a peak to peak entry.
			if (IPdeltaTime[M] > washCheck)						// Check for a wash
				WaveStats/Q/R=(t5,t5-newSearchMin) AnalysisWave
				if ((V_min < AnalysisWave(t5-newSearchMin)) && (V_minloc < IPmaxtime[M]))						// There is a wash with impact, otherwise, just a wash
					IPmin[M] = V_min
					IPmintime[M] = V_minloc
					oldtime1 = IPmaxtime[M] + timeAfterPeak
					IPdeltaTime[M] = IPmaxtime[M] - IPmintime[M]
					IPdelta[M] = IPmax[M] - IPmin[M]
				endif
				if (IPdeltaTime[M] > washCheck)					// Check if still a wash
					peak = 0
				Endif
			endif

			WaveStats/Q/R=(oldtime3,IPmintime[M]) AnalysisWave
			oldtime3 = IPmaxtime[M] + timeAfterPeak				// same as oldtime1, but we want to use the value before it's changed - used to be line below
			if ((IPdelta[M] > minDelta) && (IPmax[M] - V_avg > minPeak))		// check if the peak is too small or if it is a "negative" peak
				peak = 1									// we have a valid peak
				if (IPmin[M] < 0 && IPmax[M] > 0)			// Check the valid peaks to see if any are "negative".
//					if ((abs(IPmin[M]) - IPmax[M] > IPmax[M]) || (abs(IPmin[M]) - IPmax[M] < IPdelta[M]))	// we have a "negative" peak
//					if ((abs(IPmin[M]) > IPmax[M]) || (abs(IPmin[M]) - IPmax[M] < IPdelta[M]))	// we have a "negative" peak
					if ((abs(IPmin[M]) > IPmax[M]) && (abs(IPmin[M]) - IPmax[M] < IPdelta[M]))
						peak = 0							// we have a "negative" peak
					endif
				else
					if (IPmin[M] < 0 && IPmax[M] < 0)
						if ((abs(IPmin[M]) - IPmax[M] > (2*IPdelta[M])) || (abs(IPdelta[M] > abs(IPmax[M])*2)))
							peak = 0						// we have a "negative" peak
						else
							peak = 1						// we have a valid peak
						endif
					endif
				endif
			endif
			if (peak == 0)									// Remove the points just stored if peak is too small or a "negative" peak					
				IPmax[M] = 0
				IPmaxtime[M] = 0
				IPmin[M] = 0
				IPmintime[M] = 0
				IPdeltaTime[M] = 0
				IPdelta[M] = 0
				oldtime1 = oldtime2
			else
				M +=1	
			endif
			peak = 0										// reset variable to 0
		else												// If the last impact peak occurs very close to the 
			if ((Amp >= thresh) & (V_maxloc < oldtime1))	// DiffPeak, the max value we're looking at is on 
				start = 3									// the return portion of the impact peak, so search 
			else											// starting after oldtime1 instead.
				if (start != 1)
					start = 4	
				endif
			endif			
		endif

		if (start == 1)										// If we have just checked AnalysisWave before
			L = 0										// the first peak in Diffpkwave, L should still be 0 
			start = 2										// to check between the first and second peak.
		else
			if (start == 3)									// If we're starting from oldtime1, don't increment L
			L = L
			else	
				L += 1
			endif
		endif
	while (L < j)											// execute the loop body as long as condition is true
	
	Redimension/N=(M) IPmin, IPmintime, IPmax, IPmaxtime, IPdeltaTime, IPdelta
	If (graph == 1)										// User chose to display graphs
		Display $w
		AppendToGraph DiffPkwave; AppendToGraph IPmin vs IPmintime; AppendToGraph IPmax vs IPmaxtime
		ModifyGraph rgb(DiffPkwave) = (0,0,0)
		ModifyGraph mode(IPmin) = 3, marker(IPmin) = 22, rgb(IPmin) = (0,0,65280)
		ModifyGraph mode(IPmax) = 3, marker(IPmax) = 6, rgb(IPmax) = (0,65280,0)
	EndIf

	IPnumPnts = numpnts(IPdelta)

	If (WaveExists(:Results:$("IPD-"+NameOfWave($w))) == 1)
		KillWaves :Results:$("IPD-"+NameOfWave($w)), :Results:$("IPDT-"+NameOfWave($w)),:Results:$("IPpar-"+NameOfWave($w))
	EndIf

	If (M == 0)
		print "No Impact peaks were found matching the criteria. Channel is ", w
		Redimension/N=(1) IPdelta, IPdeltaTime				// Do this to get channel names to appear in a new column and output a 0 when files are saved.
	endif

	// Make a temporary wave to store the current parameters
	Make/O/N=10 temp
	temp[0] = thresh
	temp[1] = tmin
	temp[2] = tmax
	temp[3] = tweek
	temp[4] = minsearch
	temp[5] = washCheck
	temp[6] = newSearchMin
	temp[7] = minDelta
	temp[8] = preDiffSmooth
	temp[9] = postDiffSmooth
	MoveWave temp, :Results:$("IPpar-"+NameOfWave($w))
	
	MoveWave IPdelta, :Results:$("IPD-"+NameOfWave($w))
	MoveWave IPdeltaTime, :Results:$("IPDT-"+NameOfWave($w))
	
	If (stringmatch(existingWaves,"*IPdelta;IPdeltatime*") == 0)
		existingWaves = AddListItem("IPdelta;IPdeltatime", existingWaves,";",Inf)
	EndIf
	SetDataFolder initialDF
End
//*****End of Proc DoImpactPeaks

















//***********************************************************************************************************************
//	Function DoImpactPeaksQuery()
//		This function checks whether or not the Impact Peaks Procedure has been run already. 
//		If saved parameters exist, the user is queried about using the saved values.
Function DoImpactPeaksQuery()
	
	String  w = "Impactwave", channelList = "", query//, gotoFolderName = "", folderList = ""
	String/G AnalysisChannel = ""
	NVAR numChannelsPerRun = root:numChannelsPerRun
	Variable waveIndex = 0, paramsExist = 0, allAnalysis = 0//, folderIndex = 0, numFoldersInRoot = 0
		
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	determineWorkFolder(allAnalysis)
	
	// Declare and use the duration variable from the current data folder. Declare and set other parameters.
	NVAR Duration = :Duration
	Variable thresh=0.6, tmin, tmax=Duration, tweek=0.05, minSearch=6, washCheck=4, newSearchMin=2, minDelta=0.3, preDiffSmooth = 3001, postDiffSmooth = 1001
	
	// Get a list of only the waves that represent channels instead of all waves in the folder -- WaveList("*", ";", "")
	do
		channelList = channelList + GetIndexedObjName(":",1,waveIndex) + ";"
		waveIndex += 1
	while (waveIndex < numChannelsPerRun)
	
	// Prompt the user for a wave to find peaks
	Prompt w,"Select Wave Impact Time History to Analyze",popup, channelList
	DoPrompt "Select Wave to Analyze", w
	If (V_flag != 0)										// User cancelled
		SetDataFolder root:
		return -1
	EndIf

	AnalysisChannel = w
	WAVE parameters = :Results:$("IPpar-"+NameOfWave($AnalysisChannel))
	
	// If impact peaks were previously found for the selected channel, ask if the program 
	// should use stored parameter values or accept new ones
	If (WaveExists(:Results:$("IPpar-"+NameOfWave($AnalysisChannel))) == 1)
		Prompt query, "Parameters already exist for this channel. Do you wish to use them?", popup, "yes;no"
		DoPrompt "Use saved Parameters?", query
		If (V_flag != 0)									// User cancelled
			SetDataFolder root:
			return -1
		EndIf
			
		If (stringmatch(query, "yes") == 1)
			paramsExist = 1
			thresh = parameters[0]
			tmin = parameters[1]
			tmax = parameters[2]
			tweek = parameters[3]
			minSearch = parameters[4]
			washCheck = parameters[5]
			newSearchMin = parameters[6]
			minDelta = parameters[7]
			preDiffSmooth = parameters[8]
			postDiffSmooth = parameters[9]
			DoImpactPeaks(w, thresh, tmin, tmax, tweek, minSearch, washCheck, newSearchMin, minDelta, preDiffSmooth, postDiffSmooth)
			print "Channel =",w, "Threshold =",thresh, "Start time =",tmin, "Finish time =",tmax, "Smallest Peak in Derivative =",tweek, "Time to look behind IPmax =",minSearch
			print "Wash-check time between IPmin and IPmax =",washCheck, "New Time to look behind IPmax =",newSearchMin, "Minimum delta between IPmin and IPmax =",minDelta
			print "Number of points for smoothing pre-differentiation =", preDiffSmooth, "Number of points for smoothing post-differentiation =", postDiffSmooth
		EndIf
	EndIf
	
	// Accept new parameters.
	If (paramsExist == 0)
		Prompt thresh,"Minimum Threshold (Eu's)"
		Prompt tmin,"Start time (seconds)"
		Prompt tmax, "Finish time (seconds)"
		Prompt tweek, "Smallest Peak in Derivative"
		Prompt minSearch, "Time to look behind IPmax (seconds)"
		Prompt washCheck, "Wash-check time between IPmin and IPmax (seconds)"
		Prompt newSearchMin, "New Time to look behind IPmax if a wash is found (seconds)"
		Prompt minDelta, "Minimum delta between IPmin and IPmax (Psi)"
		DoPrompt "Enter parameters", thresh,tmin,tmax,tweek,minSearch,washCheck,newSearchMin,minDelta
		If (V_flag != 0)										// User cancelled
			SetDataFolder root:
			return -1
		EndIf
		Prompt preDiffSmooth, "Number of points for boxcar smoothing window before differentiating"
		Prompt postDiffSmooth, "Number of points for boxcar smoothing window after differentiating"
		DoPrompt "Enter the number of points in the smoothig window for boxcar smoothing", preDiffSmooth, postDiffSmooth
		DoImpactPeaks(w, thresh, tmin, tmax, tweek, minSearch, washCheck, newSearchMin, minDelta, preDiffSmooth, postDiffSmooth)
		print "Channel =",w, "Threshold =",thresh, "Start time =",tmin, "Finish time =",tmax, "Smallest Peak in Derivative =",tweek, "Time to look behind IPmax =",minSearch
		print "Wash-check time between IPmin and IPmax =",washCheck, "New Time to look behind IPmax =",newSearchMin, "Minimum delta between IPmin and IPmax =",minDelta
		print "Number of points for smoothing pre-differentiation =", preDiffSmooth, "Number of points for smoothing post-differentiation =", postDiffSmooth
//		print w, thresh, tmin, tmax, tweek, minSearch, washCheck, newSearchMin, minDelta, preDiffSmooth, postDiffSmooth
	EndIf
	SetDataFolder root:
End
//*****End of Function DoImpactPeaksQuery





//***********************************************************************************************************************
//	Functoin ImpactPeaksParameterTable()
//		This function makes a table of all the parameters that were used in the DoImpactPeaks procedure
Function ImpactPeaksParameterTable()

	Variable dummy = 0, index=0
	String ParameterList = "", TheWave = ""
	
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	determineWorkFolder(dummy)
	SetDataFolder :Results:
	
	ParameterList = WaveList("IPpar-*", ";", "")	// Make a list of all the parameters used in previous analyses
	Edit IPparams

	Do
		// get the next wave name from the list
		TheWave = GetStrFromList(ParameterList, index, ";")
		if (strlen(TheWave)==0)
			break
		else
		AppendToTable $TheWave
      		index+=1
      		endif
	While (1)					// as long as condition is true
End
//*****End of Function ImpactPeaksParameterTable















//***********************************************************************************************************************
//	Function DoWaveWhippingCombinedQuery()
//		This function calls the wave peaks procedure and whipping peaks procedure.
Function DoWaveWhippingCombinedQuery()

	String   w="LPwave", ww="HPwave", www="Unfilteredwave", filterList="", tempList="", query, channelList = ""
	Variable waveIndex = 0, paramsExist = 0, allAnalysis = 0
	
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	determineWorkFolder(allAnalysis)
	
	// If this procedure has been done before, kill the waves it creates so they are initialized properly.
//	KillWhipping()
	KillWPandWhipping()
	
	// Declare and use the duration variable from the current data folder. Declare and set other parameters.
	NVAR Duration = :Duration, numChannelsPerRun = root:numChannelsPerRun
	Variable tmin=0, tmax=Duration, trig=15000, WhipRatio=3, int=20
	
	// Get a list of only the waves that represent channels instead of all waves in the folder -- WaveList("*", ";", "")
	do
		channelList = channelList + GetIndexedObjName(":",1,waveIndex) + ";"
		waveIndex += 1
	while (waveIndex < numChannelsPerRun)
	
	// Check that High Pass filtered waves exist.
	tempList =  WaveList("*HP",";","")
	If (strlen(tempList) == 0)
		SetDataFolder root:
		Abort "Make sure waves you want to analyze in the Do Whipping procedure end with 'HP'"
	EndIf
	
	// Check that Low Pass filtered waves exist.
	tempList =  WaveList("*LP",";","")
	If (strlen(tempList) == 0)
		SetDataFolder root:
		Abort "Make sure waves you want to analyze in the Wave Peaks procedure end with 'LP'"
	EndIf
	
	// Prompt the user for a low pass filtered wave, high pass filtered wave, and unfiltered wave to analyze
	Prompt w,"Select Low Pass Wave to Analyze",popup, WaveList("*LP",";","")
	Prompt ww,"  Select Hi Pass Wave to Analyze",popup, WaveList("*HP",";","")
	Prompt www,"Select Corresponding Unfiltered Wave Impact Time History",popup, channelList
	DoPrompt "Low and Hi Pass Analysis", w, ww, www
	If (V_flag != 0)
		SetDataFolder root:
		return -1
	EndIf

	// Create a reference to the wave containing the whipping peaks parameters for the selected wave in the Results subfolder of the current folder
	WAVE parameters = :Results:$("WhPar-"+NameOfWave($ww))

	// If whipping peaks were previously found for the selected channel, ask if the program 
	// should use stored parameter values or accept new ones
	If (WaveExists(:Results:$("WhPar-"+NameOfWave($ww))) == 1)
		Prompt query, "Parameters already exist for this channel. Do you wish to use them?", popup, "yes;no"
		DoPrompt "Use saved Parameters?", query
		If (V_flag != 0)									// User cancelled
			SetDataFolder root:
			return -1
		EndIf
			
		If (stringmatch(query, "yes") == 1)
			paramsExist = 1
			tmin = parameters[0]
			tmax = parameters[1]
			trig = parameters[2]
			WhipRatio = parameters[3]
			int = parameters[4]
			DoWavePeaks(w,tmin,tmax)
			DoWhippingAndCombined(ww,www,tmin,tmax,trig, WhipRatio,int)
			print "High pass wave = ", ww, "Channel = ",www, "Start time = ",tmin, "Finish time = ",tmax, "Whipping load minimum threshold = ",trig
			print "Whipping peak found is this amount greater than threshold = ", WhipRatio, "Time span of whip event = ", int
//			print "Portion of time span from threshold time to HPmax = ", width, "Portion of time span to calculate areas  (seconds) = ", dt, "Max area ratio for whip event = ", ratio
		EndIf
	EndIf
	
	// Accept new parameters.
	If (paramsExist == 0)
		Prompt tmin,"Start time (seconds)"
		Prompt tmax, "Finish time (seconds)"
		Prompt trig,"Whipping load minimum threshold"
		Prompt WhipRatio, "Peak is greater than threshold by ratio:"
		Prompt int,"Time span of whip event"
		DoPrompt "Hi Pass Analysis Parameters", tmin, tmax, trig, WhipRatio, int
		If (V_flag != 0)
			SetDataFolder root:
			return -1
		EndIf
		
		If (WaveExists(:Results:$("WhPar-"+NameOfWave($ww))) == 1)
			KillWaves :Results:$("WhPar-"+NameOfWave($ww))
		EndIf
		
		Make/O/N=5 temp
		temp[0] = tmin
		temp[1] = tmax
		temp[2] = trig
		temp[3] = WhipRatio
		temp[4] = int
		MoveWave temp, :Results:$("WhPar-"+NameOfWave($ww))
		
		DoWavePeaks(w,tmin,tmax)
		DoWhippingAndCombined(ww,www,tmin,tmax,trig, WhipRatio,int)	
		print  w, ww, www, tmin, tmax, trig, WhipRatio, int
	EndIf
	SetDataFolder root:
End
//*****End of Function DoWaveWhippingCombinedQuery()











//***********************************************************************************************************************
//	Function DoWavePeaks(w,tmin,tmax)
Function DoWavePeaks(w,tmin,tmax)
	String  w
	Variable tmin
	Variable tmax

	Variable i=0, j=0, t1=0, t2=0, lim=0
	Variable/G WPnumPnts
	String/G LPwave = w
	SVAR existingWaves = :Results:existingWaves
	Make/O W_FindLevels
		
	FindLevels/D=W_FindLevels/Q/R=(tmin,tmax) $LPwave,0  // find time of zero crossings
	lim=trunc(V_LevelsFound/2)         // there will be half as many peaks as zero crossings found
	Make/D/O/N=(lim) WavePeaks,LPmin,LPmintime,LPmax,LPmaxtime  //make a wave peak output wave

	// Loop over zero crossings
	Do
		t1=W_FindLevels[i]            			//Pick out time for one cycle
		t2=W_FindLevels[i+2]

		//Find peak in $LPwave between t1 and t2 time periods
		WaveStats/Q/R=(t1,t2) $LPwave
		WavePeaks[j]=V_max-V_min			// form a peak to peak entry
		LPmin[j]=V_min
		LPmintime[j]=V_minloc
		LPmax[j]=V_max
		LPmaxtime[j]=V_maxloc
		j +=1
		i +=2								// execute outer loop by two
	While (j < lim)								// as long as condition is true
	WPnumPnts = numpnts(WavePeaks)
	
	If (WaveExists(:Results:$("WP-"+NameOfWave($LPwave))) == 1)
		KillWaves :Results:$("WP-"+NameOfWave($LPwave)), :Results:$("LPmin-"+NameOfWave($LPwave)),:Results:$("LPmax-"+NameOfWave($LPwave)),  :Results:$("LPminT-"+NameOfWave($LPwave)),:Results:$("LPmaxT-"+NameOfWave($LPwave))
	EndIf

	If (WPnumPnts == 0)
		print "No wave peaks were found matching the criteria. Channel is ", LPwave
//		Redimension/N=(1) WavePeaks 				// Do this to get channel names to appear in a new column and output a 0 when files are saved.
	endif

	MoveWave WavePeaks, :Results:$("WP-"+NameOfWave($LPwave))
	MoveWave LPmin, :Results:$("LPmin-"+NameOfWave($LPwave))
	MoveWave LPmintime, :Results:$("LPminT-"+NameOfWave($LPwave))
	MoveWave LPmax, :Results:$("LPmax-"+NameOfWave($LPwave))
	MoveWave LPmaxtime, :Results:$("LPmaxT-"+NameOfWave($LPwave))

	If (stringmatch(existingWaves,"*Wave Peaks*") == 0)
		existingWaves = AddListItem("Wave Peaks;LPmin;LPmax", existingWaves,";",Inf)
	EndIf
End
//*****End of Function DoWavePeaks













//***********************************************************************************************************************
Function DoWhippingAndCombined(ww,www,tmin,tmax,trig,WhipRatio,int)
	String ww
	String www
	Variable tmin
	Variable tmax
	Variable trig
	Variable WhipRatio
	Variable int
	
	Variable  i=0,j=0,t1=0,t2=0,area1,area2,area1BYarea2,ta,tb,checkspan,checkspan2,bothspan,sizeflag, allAnalysis=0, t1check, oldV_maxloc
	// i counts events.		 j counts whip events.
	Variable ratio = 0.9, width = int/2, dt = int/4
	// ratio is the max area ratio for the whip event.
	// width is the portion of time span from threshold time to HPmax (seconds). This only initializes the variable. The value changes during the program.
	// dt is the portion of time span to calculate areas (seconds). This only initializes the variable. The value changes during the program.
	Variable/G interval=int,NumwhipPks=0,V_levelsCount=0, newInterval=int  // paramters needed for the combined peaks evaluation  make int global search time or user defined time between whipping
	// NumwhipPks counts whipping peaks.		V_levelsCount same as V_LevelsFound renamed for use only as whip triggers
	Variable whipflag //,DecSize,Time2Decay         // parameters for logrithmic dec calc
	String tempList=""
	String/G HPwave, UnfilteredWave
	Make/O PulseLevelTimes					// Make a wave to hold results from FindLevels
	SVAR existingWaves = :Results:existingWaves
	tmin = 0
	HPwave = ww
	UnfilteredWave = www
	
	// Generate a wave equal to the absolute values of the high pass wave to calculate areas and find level crossings
	Duplicate/O $ww ABSwave
	ABSwave=abs(ABSwave)
              
	// Store the time of the level crossing values in PulseLevelTimes
	// V_LevelsFound is the number of level crossings
	FindLevels/Q/D=PulseLevelTimes/R=(tmin,tmax) ABSwave,trig  // find times at which trigger value is crossed
	V_levelsCount = V_LevelsFound
     
	// Find the peaks at each PulseLevelTime and determine if it is whipping
	// Make Whipping peak to peak output waves 
	Make/D/O/N=(V_LevelsCount) WhippingPeaks,HPmin,HPmintime,HPmax,HPmaxtime,areakeep //,LDec,DeltaTime,TransFreq
	Make/D/O/N=(V_LevelsCount) ithappened,area1keep,area2keep
	// Make a peak to peak output waves for combined peaks
	Make/D/O/N=(V_LevelsCount) CombinedPeaks,combmax,combmin,combmaxtime,combmintime
//	Make/D/O/N=(100) Dec_FindLevels             //array of peaks for log dec calc in time interval
  
	do
//		interval = int		//NEWNEWNEW
		t1 = PulseLevelTimes[i]
		If (t1 >= oldV_maxloc-dt)			// Check that 
			t2 = t1 + int
			If (t2 >= tmax)			// account for times extending past data record
				t2 = tmax
			EndIf

			checkspan = 0
			checkspan2 = 0
			bothspan = 0
		
//		interval = 2 * dt	//NEWNEWNEW

			//Find peak in $ww between t1 and t2 time periods go back to original wave                  
			WaveStats/Q/R=(t1,t2) $HPwave
			sizeflag = 0
			If ((V_max - V_min) > (WhipRatio * trig))    // Make sure response in whip event is much larger than threshold
				oldV_maxloc = V_maxloc
				sizeflag = 1
				// Find Two Areas on either side of Largest Amplitude after threshold in absolute value of high pass filtered data 
				WaveStats/Q/R=(t1,t2) ABSwave
				dt = (V_maxloc - t1 )	//NEWNEWNEW
				If (dt < int/4)
					dt = int/4
				EndIf
				ta = V_maxloc - dt
				tb = V_maxloc + 1.5*dt	// before peak should be smaller than after
	//		ta = V_maxloc - t1
	//		tb = ta * 3
				area1 = area(ABSwave, ta, V_maxloc)                    //Generate areas for comparison
				area2 = area(ABSwave, V_maxloc, tb)
				area1BYarea2 = area1 / area2
//			newInterval = 2 * dt	//NEWNEWNEW		// Use this value when a peak large enough was found, otherwise, use user input
//				If (newInterval < int/2)
//					newInterval = int/2
//				EndIf
				If (width > int)		//NEWNEWNEW
					newInterval = width
				Else
					width = int/2
					newinterval = int
				EndIf
//			EndIf
 		
				If (j > 0)									// We need at least one whipping peak to compare to
					If (t1 < (HPmaxtime[j-1] + .78*newInterval))             //kill logic if two events are too close in time
						sizeflag = 0
					EndIf
				EndIf
      	            
				WaveStats/Q/R=(t1,t2) $HPwave
				checkspan = V_maxloc - t1                              // make sure whip threshold & max peak are not too far apart
				checkspan2 = V_minloc - t1
				bothspan = abs(V_maxloc - V_minloc)

				//is it a whipping or ringing event?
				//compare area ratio and flags
				If ((area1BYarea2<ratio) %&  (newInterval>checkspan) %&  (newInterval >checkspan2) %& (sizeflag==1))   //ratio // old version included %& ((width*0.25)>bothspan)
					areakeep[j] = area1BYarea2                  // Save the areas around whipping events for comparison 
					area1keep[j] = area1
					area2keep[j] = area2
					//------------------------------------------------------------------------------                                      
					WhippingPeaks[j] = V_max - V_min  // form a peak to peak entry
					HPmax[j] = V_max                             // form a max entry
					HPmin[j] = V_min                              // form a min entry
					HPmaxtime[j] = V_maxloc                 // enter max time
					HPmintime[j] = V_minloc                  // enter min time
					Ithappened[j] = PulseLevelTimes[i]
					whipflag = 1
					//------------------------------------------------------------------------------                                      

					// Store Combined peaks here, after we have just found a whipping peak, so we can use the current interval
					// find the peaks occuring during each whipping time period
					//Find peak in $www between t1 and t2 time periods
					WaveStats/Q/R=(ta,tb) $UnfilteredWave
					CombinedPeaks[j]=V_max-V_min			// form a peak to peak entry
					combmax[j]=V_max							// form a max entry
					combmin[j]=V_min							// form a min entry
					combmaxtime[j]=V_maxloc					// enter max time
					combmintime[j]=V_minloc					// enter min time    

					// THIS ISN'T USED ANYMORE
					//Calculate Logdecrement of each whipping event
//					Time2Decay =V_maxloc+Interval
//					FindLevels/Q/D=Dec_FindLevels/R=(V_maxloc,Time2Decay)  $ww,0  // find zero crossings after threshold for the whole interval
//					DecSize=trunc(V_LevelsFound/2)                  // there will be half as many peaks as zero crossing pairs
            
					j += 1                                                                //increment whipping event counter
					NumwhipPks = j                                                  //Set parameters needed later in the "Combined" macro 
//					newInterval = 2 * dt	//NEWNEWNEW
//					t1check = tb
//					t1check = V_maxloc + dt
					width = 2*dt
				Else
					whipflag = 0
           			EndIf
			EndIf
		EndIf
		i += 1                                      // execute outer loop once for each PulseLevelTime
	While (i < V_LevelsCount)         // run do-while as long as condition is true number of thresholds exceeded
     
	Redimension/N=(NumwhipPks) WhippingPeaks,HPmin,HPmintime,HPmax,HPmaxtime,Ithappened,areakeep //,LDec,DeltaTime,TransFreq
	Redimension/N=(NumwhipPks) area1keep,area2keep
	Redimension/N=(NumwhipPks) CombinedPeaks,combmax,combmin,combmaxtime,combmintime
	
	If (WaveExists(:Results:$("WhP-"+NameOfWave($HPwave))) == 1)
		KillWaves :Results:$("WhP-"+NameOfWave($HPwave)), :Results:$("HPmin-"+NameOfWave($HPwave)),:Results:$("HPmax-"+NameOfWave($HPwave)),  :Results:$("HPminT-"+NameOfWave($HPwave)),:Results:$("HPmaxT-"+NameOfWave($HPwave))
		KillWaves :Results:$("CombP-"+NameOfWave($UnfilteredWave)), :Results:$("Cmin-"+NameOfWave($UnfilteredWave)), :Results:$("CminT-"+NameOfWave($UnfilteredWave)), :Results:$("Cmax-"+NameOfWave($UnfilteredWave)), :Results:$("CmaxT-"+NameOfWave($UnfilteredWave))
	EndIf
	
	If (NumwhipPks == 0)
		print "No whipping peaks were found matching the criteria. Channel is ", HPwave
//		Redimension/N=(1) WavePeaks 				// Do this to get channel names to appear in a new column and output a 0 when files are saved.
	endif

	// Move waves created for whipping peaks
	MoveWave WhippingPeaks, :Results:$("WhP-"+NameOfWave($HPwave))
	MoveWave HPmin, :Results:$("HPmin-"+NameOfWave($HPwave))
	MoveWave HPmintime, :Results:$("HPminT-"+NameOfWave($HPwave))
	MoveWave HPmax, :Results:$("HPmax-"+NameOfWave($HPwave))
	MoveWave HPmaxtime, :Results:$("HPmaxT-"+NameOfWave($HPwave))
	// Move waves created for combined peaks
	MoveWave CombinedPeaks, :Results:$("CombP-"+NameOfWave($UnfilteredWave))
	MoveWave combmin, :Results:$("Cmin-"+NameOfWave($UnfilteredWave))
	MoveWave combmintime, :Results:$("CminT-"+NameOfWave($UnfilteredWave))
	MoveWave combmax, :Results:$("Cmax-"+NameOfWave($UnfilteredWave))
	MoveWave combmaxtime, :Results:$("CmaxT-"+NameOfWave($UnfilteredWave))
	
	If (stringmatch(existingWaves,"*Whipping Peaks*") == 0)
		existingWaves = AddListItem("Whipping Peaks;HPmin;HPmax;Combined Peaks;combmin;combmax", existingWaves,";",Inf)
	EndIf
End
//*****End of Function DoWhippingAndCombined










//***********************************************************************************************************************
//	Function DoWeibull(numPntsWeibull, allWeibull, xit, AnalysisWave)
//		Create a Weibull Distribution Plot using the results from Impact Peaks.
//		If you want to change the default value of numPntsWeibull, change the value in the menu function call.
Function DoWeibull(numPntsWeibull, allWeibull, xit, AnalysisWave)
	Variable numPntsWeibull
	Variable allWeibull
	Variable xit
	String AnalysisWave
	
	String AnalysisWaveType = "", LookFor = ""
	Variable count = 0, numPntsInWave = 0, x0, x1, i=0, xmin=0, xmax, allAnalysis//, folderIndex = 0, numFoldersInRoot = 0
	Variable/G root:IsRepeat = 0
	NVAR numChannelsPerRun = root:numChannelsPerRun, Weibullindex = root:Weibullindex, IsRepeat = root:IsRepeat
	NVAR/Z graph = root:graph
	String gotoFolder = "", gotoFolderName = ""//, folderList = ""
	WAVE/T Channel = root:ChannelName, Run = root:SetRun

	If (allWeibull == 0)	// Skip this section if all Weibull estimations are done at once
		// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
		allAnalysis = 0
		determineWorkFolder(allAnalysis)
	EndIf	//(allWeibull == 0)
	gotoFolderName = GetDataFolder(0)
	gotoFolder = GetDataFolder(1)								// Get full path of current data folder
	SVAR existingWaves = :Results:existingWaves

	// Declare and use the duration variable from the current data folder. Declare other global variables we want in the current folder.
	NVAR Duration= :Duration
	Variable/G xx0=x0  								// Create a global version of x0 to allow later annotation.
	Variable/G chv, PMax, corr, slopeYwave, interceptYwave, PredictedMax, waveV_Avg, waveV_min, waveV_max, waveV_sdev, ImpactsPerHour

	If (allWeibull == 0)	// Skip this section if all Weibull estimations are done at once
		// Promp the user to select a wave to perform Weibull anaylsis on from those saved in the Results subfolder
		SetDataFolder :Results:
		Prompt numPntsWeibull, "Enter the minimum number of points the Weibull estimation should use"
		Prompt AnalysisWaveType, "Select the type of wave to perform Weibull analysis on", popup, existingWaves
		Prompt xit, "Enter the number of iterations for x0"
		DoPrompt "Weibull Analysis", numPntsWeibull, AnalysisWaveType, xit
		If (V_flag != 0)											// User cancelled
			SetDataFolder root:
			return -1
		EndIf
		
		LookFor = GetAnalysisWaveType(AnalysisWaveType)
		
		Prompt AnalysisWave, "Select the wave to perform Weibull analysis on", popup, Wavelist(LookFor,";","")
		DoPrompt "Weibull Analysis", AnalysisWave
		If (V_flag != 0)											// User cancelled
			SetDataFolder root:
			return -1
		EndIf
		SetDataFolder gotoFolder
	EndIf	//(allWeibull == 0)
	
	// Check if Weibull parameters already exist. If so, set the index, Weibullindex, to overwrite them.
	For (count=0;count<numChannelsPerRun;count+=1)
		If (strlen(Channel[count]) == 0)
			If (IsRepeat == 0)
				Weibullindex = count
			EndIf
			break
		Else
			If (stringmatch(gotoFolderName, Run[count]) == 1)
				If (stringmatch(AnalysisWave, Channel[count]) == 1)
					IsRepeat = 1
					Weibullindex = count
				EndIf
			EndIf
		EndIf
	EndFor
	
	// Check if no impacts were found.
	numPntsInWave = numPnts(:Results:$AnalysisWave)
	If (numPntsInWave == 0)
		SetDataFolder root:
		Abort "No impact peaks found. QUITTING!"
	EndIf
	
	// Make sure the user chose to display or supress graphing.
	If (exists("root:graph") == 0)
		SetDataFolder root:
		Abort "First choose if you wish to display graphs!"
	EndIf

	// Get and store stats from the analysis wave for later use.
	WaveStats/Q :Results:$AnalysisWave
	xmax = V_min - 0.01*V_min						// Choose xmax to be 1% of the minimum Y value of analysis wave.
	waveV_avg = V_avg									
	waveV_min = V_min
	waveV_max = V_max
	waveV_sdev = V_sdev
	
	// If there are a sufficient number of points to perform Weibull analysis, do it.
	If (numPntsInWave >= numPntsWeibull)
		Duplicate/O :Results:$AnalysisWave XWave, x0wave  		// Create a wave for the x value coordinates.
		XWave = abs(XWave)

		Sort  Xwave Xwave  										// Perform sort in ascending order.
		Make/O/N=(xit+1)  xtest, Rtest								// Make waves to hold iteration parameters.
		xtest = (xmax - xmin)/xit*x + xmin							// Create wave to range from min to max x0 values.
		Make/O/D/N=(numPntsInWave) Ywave = ln(ln(1/(1 - (p + 1)/(numPntsInWave+1)))) // Create ywave.

		Silent 1; PauseUpdate
		If (xit > 0)
			do
				x0wave = ln(Xwave - xtest[i])
				CurveFit/Q line Ywave/D /x=x0wave   					// Done to find best X0 or XX0.
				Rtest[i] = V_Pr										// Store the correlation coefficient (Pearson's R).
				//print Rtest[i], xtest[i]
				i+= 1
			while (i < xit+1)
	
			If (graph == 1)											// User chose to display graphs
				// Plot Rtest vs xtest for a visual of highest correlation
				display rtest vs xtest
			EndIf
			WaveStats/Q Rtest
			xx0 = xtest[V_maxloc]									// This is the xo value  of Rtest which gives the highest correlation
		EndIf
    
		Make/O/D/N=(numPntsInWave) NewXwave = Xwave - xx0			// Sorted Data minus Xo
		Xwave = ln(NewXwave) 									// Create wave representing ln(x-x0)
//		Make/O/D/N=(numPntsInWave) Ywave = ln(ln(1/(1 - (p + 1)/(numPntsInWave+1)))) // Create ywave
    
		If (graph == 1)											// User chose to display graphs
			// Plot linear regression results for Impact Peaks
			Display Ywave vs Xwave
			Label left "lnln(1/(1-P))"
			Label bottom "ln(x-x\\B0\\M)"
		EndIf
	
		CurveFit/Q line Ywave /D /X=Xwave							// Curve Fit Returns K1 and K0, slope and intercept
		corr = V_Pr
		chv = exp(-K0/K1)										// Calculate characteristic value (scale factor) from CurveFit of Ywave
		slopeYwave = K1
		interceptYwave = K0
		PMax = chv*exp(ln(ln(numPntsInWave))/slopeYwave) + xx0
    
		If (graph == 1)											// User chose to display graphs
			// Finish plot of linear regression results for Impact Peaks
			Textbox/N=text1/F=0/A=MT/E " \\Z14Linear Regression Results for Impact Peaks"
			UpdateGraph(corr, xx0, slopeYwave, chv, interceptYwave, waveV_avg, waveV_min, waveV_max, waveV_sdev, Pmax, numPntsInWave, AnalysisWave)
			ModifyGraph mode(Ywave)=3, marker(Ywave)=42, rgb(Ywave)=(0,0,0), lsize(fit_Ywave)=2; DelayUpdate
			ModifyGraph rgb(fit_Ywave)=(34952,34952,34952)
			ModifyGraph grid=1, zero(left)=1
			ModifyGraph mirror(left)=2
			ModifyGraph mirror=2
		EndIf

		Make/O/D/N=(numPntsInWave) lnPredicted = ((-1.0*interceptYwave) + Ywave)/slopeYwave
		Make/O/D/N=(numPntsInWave)  Predicted = exp(lnPredicted)
		PredictedMax = Predicted[numPntsInWave]
    
		Make/O/D/N=(numPntsInWave) Pofx = (p + 1)/(numPntsInWave+1)		// Create ywave
		If (graph == 1)											// User chose to display graphs
			// New Plot - Estimates for Impact Peaks
			Display PofX vs NewXwave
			AppendToGraph PofX vs Predicted  
			Label left "Cumulative Value"
			Label bottom "Measured and Predicted (line)"
			Textbox/N=text1/F=0/A=MT/E "\\Z14Estimates for Impact Peaks"
			UpdateGraph(corr, xx0, slopeYwave, chv, interceptYwave, waveV_avg, waveV_min, waveV_max, waveV_sdev, Pmax, numPntsInWave, AnalysisWave)
			ModifyGraph mode(PofX)=3, marker(PofX)=42, rgb(PofX)=(0,0,0),  lsize(PofX#1)=2; DelayUpdate
			ModifyGraph rgb(PofX#1)=(34952,34952,34952)
			ModifyGraph grid=1, zero(left)=1
			ModifyGraph mirror(left)=2
			ModifyGraph mirror=2
		EndIf

		ImpactsPerHour = numPntsInWave / Duration * 3600
		StoreParameters(gotoFolderName, AnalysisWave, allWeibull, corr, slopeYwave, interceptYwave, xx0, chv, Pmax, waveV_min, waveV_max, waveV_avg, waveV_sdev, numPntsInWave, ImpactsPerHour)
		SetDataFolder root:
	Else	// There are too few points to perform Weibull analysis
		corr=0; slopeYwave=0; interceptYwave=0; xx0=0; chv=0; Pmax=0
		If (numPntsInWave == 1)
			waveV_min=0; waveV_avg=0; waveV_sdev=0
		EndIf
//		Abort "There are too few points to perform Weibull analysis"
	EndIf
	
//	ImpactsPerHour = numPntsInWave / Duration * 3600
//	StoreParameters(gotoFolderName, AnalysisWave, allWeibull, corr, slopeYwave, interceptYwave, xx0, chv, Pmax, waveV_min, waveV_max, waveV_avg, waveV_sdev, numPntsInWave, ImpactsPerHour)
//	SetDataFolder root:
End
//*****End of Function DoWeibull










//***********************************************************************************************************************
//	Function DoAllWeibull()
Function DoAllWeibull()

	Variable numPntsWeibull=4, allWeibull = 1, xit = 600, allAnalysis = 1, numPntsInWave = 0, waveIndex = 0
	Variable numWavesInCurrentFolder = 0, folderIndex = 0, numFoldersInRoot = 0
	String gotoFolder = "", folderList = "", gotoFolderName = "", currentWave = "", AnalysisWaveType = "", LookFor = ""
	NVAR numChannelsPerRun = root:numChannelsPerRun, Weibullindex = root:Weibullindex
	
	Weibullindex = 0				// Reset Weibullindex to zero.
	
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	folderList = determineWorkFolder(allAnalysis)
	numFoldersInRoot = ItemsInList(folderList)
	
	gotoFolderName = StringFromList(folderIndex,folderList)
	SetDataFolder gotoFolderName
	SVAR existingWaves = :Results:existingWaves
	SetDataFolder root:
	
	// Prompt for the minimum number of points the Weibull estimation should use.
	Prompt numPntsWeibull, "Enter the minimum number of points the Weibull estimation should use"
	Prompt AnalysisWaveType, "Select the type of wave to perform Weibull analysis on", popup, existingWaves
	Prompt xit, "Enter the number of iterations for x0"
	DoPrompt "Weibull Analysis", numPntsWeibull, AnalysisWaveType, xit
	If (V_flag != 0)											// User cancelled
		SetDataFolder root:
		return -1
	EndIf

	LookFor = GetAnalysisWaveType(AnalysisWaveType)
		
	// Cycle through the waves to do Weibull Analysis on.
	Do
//		RunName = GetIndexedObjName("", 4, folderIndex)
//		SetDataFolder RunName
		currentWave = ""
//		Variable tmax = Duration
		waveIndex = 0
		gotoFolderName = StringFromList(folderIndex,folderList)
		SetDataFolder gotoFolderName
		gotoFolder = GetDataFolder(1)								// Get full path of current data folder
		SetDataFolder :Results:
		numWavesInCurrentFolder = CountObjects(":",1)
		
		Do
			currentWave = NameOfWave(WaveRefIndexed("", waveIndex, 4))
			If (stringmatch(currentWave,LookFor) == 1)
				// Check if no impacts were found.
				numPntsInWave = numPnts($currentWave)
				If (numPntsInWave > 0)
					SetDataFolder gotoFolder
					DoWeibull(numPntsWeibull,allWeibull, xit, currentWave)
					SetDataFolder gotoFolder
					SetDataFolder :Results:
				EndIf
			EndIf
			waveIndex += 1
		While (waveIndex < numWavesInCurrentFolder)

		folderIndex += 1
		SetDataFolder root:
	while (folderIndex < numFoldersInRoot)
//	Execute "DisplayWeibullResults()"
	SetDataFolder root:
End
//*****End of Function DoAllWeibull




















//***********************************************************************************************************************
//	proc DoLewisWeibull(wwwww,seed,timesaround)
//	New Moment method of weibul TWO parameter calculations April 15 1997
//	"Do Moment Weibull by Lewis"

Function DoLewisWeibull(wwwww,seed,timesaround)
       String  wwwww
       Variable seed
       Variable timesaround
       
       Prompt wwwww,"Select Wave ",popup, WaveList("*",";","")
       Prompt Seed,"Input initial value or Seed for Slope"
       Prompt TimesAround,"Input max iterations on slope"

       Variable  LeftSide,RightSide,val1,val2,Compare
       Variable x1,MtypeNo,i,gogo,top,bottom,ii,jj
        
      String/G gtitle=wwwww
      String/G newstring="Absolute Value of "
      Variable/G Mchv,Mbeta,Mintercept ,MPmax,MESTM2VAL,MeanSqr
	
	// Set values for these waves
	
	if (!(Cmpstr(gtitle,"WavePeaks")))
		MtypeNo=0
	endif
	
	if (!(Cmpstr(gtitle,"LPmin")))
		MtypeNo=1
		gtitle=newstring + gtitle
	endif
	
	if (!(Cmpstr(gtitle,"LPmax")))
		MtypeNo=2
	endif
	
	if (!(Cmpstr(gtitle,"WhippingPeaks")))
	 	MtypeNo=3
	 endif
	
	if (!(Cmpstr(gtitle,"HPmin")))
		MtypeNo=4
		gtitle=newstring + gtitle
	endif
	
	if (!(Cmpstr(gtitle,"HPmax")))
		MtypeNo=5
	endif
	
	if (!(Cmpstr(gtitle,"CombinedPeaks")))
		MtypeNo =6
	endif
	
	if (!(Cmpstr(gtitle,"combmin")))
		MtypeNo =7
		gtitle=newstring + gtitle
	endif
	
	if (!(Cmpstr(gtitle,"combmax")))
		MtypeNo =8
	endif
//***************************
Make/O/T Mtype = {"MWavePeak","MLPmin","MLPmax","MWhippingPeak","MHPmin","MHPmax","MCombinedPeak","Mcombmin","Mcombmax"}// Create Analysis type wave
Make/D/O/N=9 Mslope,Mch_value,Mcorr,Mxzero,Mwmin,Mwmax,Mwavg,Mwsdev,Mwpoints,MCovHere,Mintcp,MmostProb,MPredictedMax //Create a wave to hold the respective parameters
Make/D/O/N=9 EstMeanSquare
//Get Stats from time history

    WaveStats/Q $wwwww                         // Find out how many points there are
    Duplicate/O $wwwww MXWave            // Create a wave for the x value coordinates
    MXWave=abs(MXWave)
    Sort  MXwave MXwave                       // Perform sort in ascending order
    Duplicate/O  MXWave  lnMXWave     // Create a wave for the x value coordinates
    lnMXWave=ln(lnMXWave)
    Mxzero[MtypeNo]=0.0
    Mwmin[MtypeNo]=V_min
    Mwmax[MtypeNo]=V_max
    Mwavg[MtypeNo]=V_avg
    Mwsdev[MtypeNo]=V_sdev
    Mwpoints[MtypeNo]=V_npnts
    MCovHere[MtypeNo]=V_sdev/V_avg
    
 
//Need to use moment method to find  Characteristic value and Slope
//what is gammp(a,x)
//what is gammq(a,x)
gogo=0
Compare=0.0
RightSide=0.0
LeftSide=0.0

LeftSide=((V_sdev)^2/(V_avg)^2)+1

if(Seed<=0)
   Mbeta=0.5
else
   Mbeta=Seed
endif
Silent 1; PauseUpdate   
	do
		val1=(1+(2/Mbeta))							// execute the loop body
		val2=(1+(1/Mbeta))

		 Top=gammln(val1)
		 Bottom=gammln(val2)
		 
		RightSide=(exp(top)/(exp(bottom))^2)
		Compare=abs(LeftSide-RightSide)
		gogo=gogo+1
		if (Compare<0.0005)
			gogo=TimesAround							// execute if condition is true
		endif
		Mbeta=Mbeta+0.001
	while (gogo<TimesAround)					// as long as condition is true

    Mchv=Mwavg[MtypeNo]/(exp(bottom))
    
    Mslope[MtypeNo]=Mbeta

    Mch_value[MtypeNo]=Mchv
    
    Mintercept = -Mbeta*(ln(abs(Mchv)))
    Mintcp[MtypeNo]=Mintercept 
    
    MPmax=Mchv*(exp(ln(ln(Mwpoints[MtypeNo]))/Mslope[MtypeNo]))
    MmostProb[MtypeNo]=MPmax
    
    //How well are weibull parameters estimated if compared to mean square of data 
    
    MeanSqr=(V_sdev*V_sdev)+(V_avg*V_avg)
    
    MESTM2VAL=(Mchv*Mchv)*(exp(gammln(1+(2/Mbeta))))
    EstMeanSquare[MtypeNo]= MESTM2VAL
     
    Make/O/D/N=(Mwpoints[MtypeNo]) Pofx=(p+1)/(Mwpoints[MtypeNo]+1)           // Create ywave
    Make/O/D/N=(Mwpoints[MtypeNo]) MlnPredicted=((-1.0*Mintcp[MtypeNo])+ln(ln(1/(1-Pofx))))/Mslope[MtypeNo]
    Make/O/D/N=(Mwpoints[MtypeNo]) lnlnP=ln(ln(1/(1-Pofx)))
    Make/O/D/N=(Mwpoints[MtypeNo]) MPredicted=exp(MlnPredicted)
    
    MPredictedMax[MtypeNo]=(V_max/abs(V_max))*MPredicted[Mwpoints[MtypeNo]]

    Display  lnlnP vs lnMXWave
    AppendToGraph   lnlnP vs MlnPredicted 
    Label left "lnln(1/(1-P))"
    Label bottom "ln(x)"
    ModifyGraph mode(lnlnP)=3,marker(lnlnP)=42,rgb(lnlnP)=(0,0,0),lsize(lnlnP#1)=2;DelayUpdate
    ModifyGraph rgb(lnlnP#1)=(34952,34952,34952)
    Textbox/N=text1/F=0/A=MT/E "Moment Method Estimates of Two Parameter Weibull\rResults for \\{gtitle}"
    Textbox/C/N=text0 /A=RB "\\Z10Two Parameter Est\rSlope = \\{Mbeta}\rCh Value =\\{Mchv} \rIntercept = \\{Mintercept}\rMean=\\{V_avg}\rStd Dev=\\{V_sdev}\rMin=\\{V_min}\rMax=\\{V_max}\rMost Prob Max=\\{MPmax}\rNo Pts=\\{V_npnts}\rMean Square = \\{MeanSqr}\rEstimate of Mean Square =\\{MESTM2VAL} "
    Textbox/C/N=text2/F=0/E/A=MB/N=text2 "\\Z10\\{s_Wavenames}   \\{date()}\""
    ModifyGraph grid=1,zero(left)=1
    ModifyGraph mirror(left)=2
    ModifyGraph mirror=2
    
    Display   Pofx vs  MPredicted
    AppendToGraph  Pofx vs MXWave
    Label left "Cumulative Value"
    Label bottom "Measured and Moment Method Predicted   X"
    Textbox/N=text1/F=0/A=MT/E "\\Z12Moment Method Estimate of Two Parameter Weibull\r Results for \\{gtitle}"
    Textbox/C/N=text0 /A=RB "\\Z10Two Parameter Est\rSlope = \\{Mbeta}\rCh Value =\\{Mchv}\rIntercept = \\{Mintercept}\rMean=\\{V_avg}\rStd Dev=\\{V_sdev}\rMin=\\{V_min}\rMax=\\{V_max}\rMost Prob Max=\\{MPmax}\rIn \\{V_npnts} Samples \rMean Square = \\{MeanSqr}\rEstimate of Mean Square =\\{MESTM2VAL} "
    Textbox/C/N=text2/F=0/E/A=MB/N=text2 "\\Z10\\{s_Wavenames}   \\{date()}\""
    ModifyGraph mode(Pofx#1)=3,marker(Pofx#1)=42,rgb(Pofx#1)=(2,39321,1)
    ModifyGraph lsize(Pofx)=2
    ModifyGraph grid=1,zero(left)=1
    ModifyGraph mirror(left)=2
    ModifyGraph mirror=2
    ModifyGraph rgb(Pofx)=(34952,34952,34952),rgb(Pofx#1)=(0,0,0)
End
//*****End of proc DoLewisWeibull











//***********************************************************************************************************************
//	Function StoreParameters(dataSet, channel, allWeibull, corr, slope, int, x0, chv, Pmax minimum, maximum, avg, stdDev, impacts, ImpactsPerHour)
//		This function stores the Weibull and population statistics from the DoWeibull procedure into 
//		waves for global tabular access of results
Function StoreParameters(dataSet, channel, allWeibull, corr, slope, int, x0, chv, Pmax, minimum, maximum, avg, stdDev, impacts, IPH)
	String dataSet
	String channel
	Variable allWeibull
	Variable corr
	Variable slope
	Variable int
	Variable x0
	Variable chv
	Variable Pmax
	Variable minimum
	Variable maximum
	Variable avg
	Variable stdDev
	Variable impacts
	Variable IPH
	
	NVAR Weibullindex = root:Weibullindex, IsRepeat = root:IsRepeat
	WAVE/T ChannelName = root:ChannelName, SetRun = root:SetRun
	WAVE Wcorr = root:Wcorr, Wslope = root:Wslope, Wintercept = root:Wintercept, Wx0 = root:Wx0, Wchv = root:Wchv, WPmax = root:WPmax
	WAVE Wmin = root:Wmin, Wmax = root:Wmax, Wavg = root:Wavg, WstdDev = root:WstdDev, Wimpacts = root:Wimpacts, WimpactsPerHour = root:WimpactsPerHour
	
	SetRun[Weibullindex] = dataSet
	ChannelName[Weibullindex] = channel
	Wcorr[Weibullindex] = corr
	Wslope[Weibullindex] = slope
	Wintercept[Weibullindex] = int
	Wx0[Weibullindex] = x0
	Wchv[Weibullindex] = chv
	WPmax[Weibullindex] = Pmax
	Wmin[Weibullindex] = minimum
	Wmax[Weibullindex] = maximum
	Wavg[Weibullindex] = avg
	WstdDev[Weibullindex] = stdDev
	Wimpacts[Weibullindex] = impacts
	WimpactsPerHour[Weibullindex] = IPH
	Weibullindex += 1
//	If (allWeibull == 0)	// Skip this section if all Weibull estimations are done at once
//		If (IsRepeat == 1)	// User repeated analysis
//			Weibullindex -= 1
//			numWeibull = Weibullindex
//		EndIf
//	EndIf	//(allWeibull == 0)
End
//*****End of Function StoreParameters
















//***********************************************************************************************************************
//	Proc DoAllImpactWeibull(numPntsWeibull)
//		This procedure goes through all runs in a set, performing impact peaks and Weibull analysis, 
//		and stores results in corresponding waves for tabular format.
Function DoAllImpactandWeibull(numPntsWeibull, xit)
	Variable numPntsWeibull
	Variable xit
	
	Prompt numPntsWeibull, "Enter the minimum number of points the Weibull estimation should use"
	Prompt xit, "Enter the number of iterations for x0"

	Variable RunIndex = 0, channel = 0, thresh=200, tmin, tmax, tweek=20
	String RunName, savedDataFolder = GetDataFolder(1)
	
	NVAR Windex = Weibullindex
	Windex = 0				// Reset Weibullindex to zero.
	
	NVAR TrHold = threshold
	NVAR DTweek = difftweek
	if (TrHold != 0)					// If user has previously selected threshold and tweek values
		thresh = TrHold					
		tweek = DTWeek
	endif
	
	
	NVAR Dur = Duration
	NVAR NCPR = root:numChannelsPerRun
	Silent 1
	Do
		RunName = GetIndexedObjName("", 4, RunIndex)
		SetDataFolder RunName
		String/G currentChannel
		tmax = Dur

		Do
			currentChannel = NameOfWave(WaveRefIndexed("", channel, 4))
//			DoImpactPeaks(currentChannel, thresh, tmin, tmax, tweek )
			DoWeibull(numPntsWeibull,0,0,"")//need to fix this
			print "DoWeibull call from DoAllImpactandWeibull is not working."
			channel += 1
		While (channel < NCPR)

		channel = 0
		RunIndex += 1
		SetDataFolder savedDataFolder
	While (RunIndex < 1)
	Edit SetRun, ChannelName, Wcorr, Wslope, Wintercept, Wx0, Wchv, WPmax, Wmin, Wmax, Wavg, WstdDev, Wimpacts, WimpactsPerHour
	execute "ModifyTable format(WimpactsPerHour)=3,digits(WimpactsPerHour)=1"
End
//*****End of Proc DoAllImpactandWeibull












//***********************************************************************************************************************
//	Proc DisplayWeibullResults()
//		This Procedure displays all recent Weibull results in a table. Use this when performing Impact
//		Peaks and Weibull seperately.
Function DisplayWeibullResults()
	String currentDataFolder = GetDataFolder(1)
	
	SetDataFolder root:
	Edit SetRun, ChannelName, Wcorr, Wslope, Wintercept, Wx0, Wchv, WPmax, Wmin, Wmax, Wavg, WstdDev, Wimpacts, WimpactsPerHour
	execute "ModifyTable format(WimpactsPerHour)=3,digits(WimpactsPerHour)=1"
	SetDataFolder currentDataFolder
End
//*****End of Function DisplayWeibullResults











//***********************************************************************************************************************
//	Function KillimpactPeaks()
//		This function kills all waves, variables and strings created during the Impact Peaks procedure.
//		Use this when you want to re-run an analysis and be sure everything is initialized properly.
//		This is mainly for debugging purposes.
Function KillimpactPeaks()

//	Variable folderIndex = 0, numFoldersInRoot = 0
	Variable allAnalysis = 0
//	String gotoFolderName = "", folderList = ""
	
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	determineWorkFolder(allAnalysis)
		
	KillWaves/Z AnalysisWave, DiffPkwave, W_FindLevels, DiffPk2PK, DiffPkmin, DiffPkmintime, DiffPkmax, DiffPkmaxtime, halftime, IPmin, IPmintime, IPmax, IPmaxtime, IPdeltaTime, IPdelta
	KillVariables/Z IPnumPnts
	SetDataFolder root:
End
//*****End of Function KillimpactPeaks











//***********************************************************************************************************************
//	Function KillWeibull()
//		This function kills all waves and variables created during the weibull procedure.
//		Use this when you want to re-run an analysis and be sure everything is initialized properly.
//		This is mainly for debugging purposes.
Function KillWeibull()

	NVAR Weibullindex = root:Weibullindex
	Variable allAnalysis = 0
//	Variable folderIndex = 0, numFoldersInRoot = 0
//	String gotoFolderName = "", folderList = ""
	
	Weibullindex = 0			// Reset Weibullindex to zero.
	
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	determineWorkFolder(allAnalysis)
	
	KillWaves/Z XWave, x0wave, xtest, Rtest, Ywave, W_coef, fit_Ywave, W_sigma, NewXWave, lnPredicted, Predicted, Pofx
	KillVariables/Z xx0, chv, Pmax, corr, slopeYwave, interceptYwave, PredictedMax, waveV_avg, waveV_min, waveV_max, waveV_sdev, ImpactsPerHour
	SetDataFolder root:
	// Zero the Weibull indexes and waves that store Weibull results
	ZeroWeibullindex()
End
//*****End of Function KillWeibull











//***********************************************************************************************************************
//	Function ZeroWeibullindex()
//		This function is necessary if you wish to start Weibull analysis over so that the index starts from zero.
//		The waves that store Weibull results are also re-initialized. This is mainly for debugging purposes.
Function ZeroWeibullindex()
	NVAR Weibullindex = root:Weibullindex, numRunsLoaded = root:numRunsLoaded, speed = root:speed
	NVAR numChannelsPerRun = root:numChannelsPerRun
	Weibullindex = 0

	SetDataFolder root:
	// Re-Create waves to hold the Weibull and population statistics and initialize to remove previous entries
	Make/O/T/N=(numChannelsPerRun) SetRun = "", ChannelName = ""
	Make/O/D/N=(numChannelsPerRun) Wcorr = 0, Wslope = 0, Wintercept = 0, Wx0 = 0, Wchv = 0, WPmax = 0, Wmin = 0, Wmax = 0, Wavg = 0, WstdDev = 0, Wimpacts = 0, WimpactsPerHour = 0
End
//*****End of Function ZeroWeibullindex










//***********************************************************************************************************************
Function KillWPandWhipping()

	KillWaves/Z W_FindLevels, WavePeaks, LPmin, LPmintime, LPmax, LPmaxtime
	KillWaves/Z PulseLevelTimes, WhippingPeaks, HPmin, HPmintime, HPmax, HPmaxtime, areakeep, ithappened, area1keep, area2keep, Dec_FindLevels
End
//*****End of Function KillWhipping()






//***********************************************************************************************************************
//	Function SaveIPresultsToFile()
//		This function gets all of the chosen wave types in the Results folder and saves them to a delimited 
//		text file that can be used in other programs.
Function SaveIPresultsToFile()

	Variable saveType = 0, allAnalysis = 0//, folderIndex = 0, numFoldersInRoot = 0
	String ParameterList = "", IPdeltaList = "", IPdeltaTimeList = "", gotoFolder = ""//, gotoFolderName = "", folderList = ""
	
	// Determine which folder to work in by checking to see if there are multiple folders (the case with HSV)
	determineWorkFolder(allAnalysis)
	gotoFolder = GetDataFolder(1)								// Get full path of current data folder
	SetDataFolder :Results:
	
	Prompt saveType, "Choose file type to save.", popup, "impact peak parameters;impact peak '\"amplitudes\";risetime of impact peaks"
	DoPrompt "Save file", saveType
		If (V_flag != 0)											// User cancelled
			SetDataFolder root:
			return -1
		EndIf

	If (saveType == 1)
		ParameterList = WaveList("IPpar-*", ";", "")
		ParameterList = AddListItem("IPparams",ParameterList)
		Save/B/J/M="\r\n"/I/W ParameterList 
	ElseIf (saveType == 2)
		IPdeltaList = WaveList("IPD-*", ";", "")
		print IPdeltaList
		Save/B/J/M="\r\n"/I/W IPdeltaList
	ElseIf (saveType == 3)
		IPdeltaTimeList = WaveList("IPDT*", ";", "")
		Save/B/J/M="\r\n"/I/W IPdeltaTimeList
	EndIf
	
	SetDataFolder root:
End
//*****End of Function SaveIPresultsToFile()






//***********************************************************************************************************************
//	Proc ChooseImpactThresholds(threshold,difftweek)
//		This procedure should be used when using the DoAllImpactandWeibull procedure to change. Do not use 
//		when using the ImpactPeaks and Weibull procedures separately. This procedure has no relevance
//		to those. 
//		Before selecting this procedure, look at some waves in a few of the runs of the set to determine 
//		the appropriate threshold and tweek values to choose. i.e. values that have been found to work for 
//		large impacts are thresh=200 and tweek=20, smaller impacts are thresh=100 and tweek=10. For 
//		data with particularly noisy or low impacts values that work are thresh=65 and tweek=10.
Function ChooseImpactThresholds(t,d)
	Variable t
	Variable d
	
	Prompt t, "Select Wave Impact Threshold (Eu's)"
	Prompt d, "Select Smallest Peak in Derivative"
	
	Variable/G threshold = t, difftweek = d
End
//*****End of Proc ChooseImpactThresholds








//***********************************************************************************************************************
//	Function/S GetAnalysisWaveType()
Function/S GetAnalysisWaveType(AnalysisWaveType)
	string AnalysisWaveType

	string LookFor = ""
		If (stringmatch(AnalysisWaveType, "IPdelta") == 1)
			LookFor = "IPD-*"
		ElseIf (stringmatch(AnalysisWaveType, "WavePeaks") == 1)
			LookFor = "WP-*"
		ElseIf (stringmatch(AnalysisWaveType, "LPmin") == 1)
			LookFor = "LPmin-*"
		ElseIf (stringmatch(AnalysisWaveType, "LPmax") == 1)
			LookFor = "LPmax-*"
		ElseIf (stringmatch(AnalysisWaveType, "WhippingPeaks") == 1)
			LookFor = "WhP-*"
		ElseIf (stringmatch(AnalysisWaveType, "HPmin") == 1)
			LookFor = "HPmin-*"
		ElseIf (stringmatch(AnalysisWaveType, "HPmax") == 1)
			LookFor = "HPmax-*"
		ElseIf (stringmatch(AnalysisWaveType, "CombinedPeaks") == 1)
			LookFor = "CP-*"
		ElseIf (stringmatch(AnalysisWaveType, "CombinedMin") == 1)
			LookFor = "Combmin-*"
		ElseIf (stringmatch(AnalysisWaveType, "CombinedMax") == 1)
			LookFor = "Combmax-*"
		EndIf
	Return LookFor
End
//*****End of Function/S GetAnalysisWaveType()

